;************************************************
;	   Boot Loader EEPROM code 
;    (c) Andras Bognar The Quenne Electric
;	    PIC-I8085 Micro System
;************************************************

;Loading 8 sectors (2KB) to I8085 conventional RAM
;Csak a fels byte-ot hasznlja fel, az alst nem.
NOP
NOP
MVI H,0FFH;	;stack
MVI L,0FFH
SPHL
MVI H,01H
MVI L,00H
MVI D,01H	;sec

nextsec: MVI A,26H
OUT 00H
MOV A,D
OUT 00H
MVI A,00H
OUT 00H
MVI A,00H
OUT 00H
MVI A,0AH	;hd
OUT 00H
MVI C,00H	;read(256X)
nextd: NOP
IN 00H
MOV M,A
INX H
IN 00H
NOP
DCR C
JNZ nextd
INR D
MVI A,09H
CMP D
JNZ nextsec

MVI A,27H	;stop winchester
OUT 00H

MVI A,0EH	;BUTTON1->store memory to RS232
OUT 00H
NOP
IN 00H
CPI 01H
JZ RSMEM

MVI C,00H	;checksum conrol
MVI H,01H
MVI L,00H
MVI A,00H
CHCK: ADD M 
INX H
ADD M
INX H
ADD M
INX H
ADD M
INX H
ADD M
INX H
ADD M
INX H
ADD M
INX H
ADD M
INX H
DCR C
JNZ CHCK

MOV B,A		;BUTTON2->send counted checksum
MVI A,0EH
OUT 00H
NOP
IN 00H
CPI 02H
JNZ NORS
MVI A,51H
OUT 00H
MOV A,B
OUT 00H
MVI A,50H
OUT 00H
NORS: NOP
MOV A,B

ANI 0FFH
JZ NOERR

ERR: MVI A,16H	;FATALCODE
OUT 00H
MVI A,06H
OUT 00H
FATAL: JMP FATAL
NOERR: NOP

MVI H,01H	;control code (55h)
MVI L,01H
MOV A,M
CPI 55H
JNZ ERR

JMP 0102H	;jmp code

RSMEM: NOP	;STORE MEMORY TO RS232 (2304BYTE FROM 00H)
MVI C,00
MVI H,00H
MVI L,00H
MCK: MVI A,51H
OUT 00H
MOV A,M
OUT 00H
INX H
MVI A,51H
OUT 00H
MOV A,M
OUT 00H
INX H
MVI A,51H
OUT 00H
MOV A,M
OUT 00H
INX H
MVI A,51H
OUT 00H
MOV A,M
OUT 00H
INX H
MVI A,51H
OUT 00H
MOV A,M
OUT 00H
INX H
MVI A,51H
OUT 00H
MOV A,M
OUT 00H
INX H
MVI A,51H
OUT 00H
MOV A,M
OUT 00H
INX H
MVI A,51H
OUT 00H
MOV A,M
OUT 00H
INX H
MVI A,51H
OUT 00H
MOV A,M
OUT 00H
INX H
DCR C
JNZ MCK
MVI A,50H
OUT 00H
STOP: JMP STOP

END