;************************************************
;	    Lv jtk program 
;     for BANDS SPECTRUM OPERATING SYSTEM
;    (c) Andras Bognar The Quenne Electric
;	    PIC-I8085 Micro System
;************************************************

ORG 100H
NOP			;place of CHECKSUM
DB	55H		;control code
JMP START

;variables
MLX:	DB 00H		;cltrgy - lvedk
MLY: 	DB 00H		;cltrgy - lvedk
MX:	DB 16H		;cltrgy poz.
LX:	DB 0FH		;gy poz.
LOVX:	DB 00H		;gy lvedk
LOVY:	DB 00H		;gy lvedk
LOVES:	DB 00H		;flag
MLOVES:	DB 00H		;flag
MDIR:	DB 01H		;cltrgy irnya
MDLY:	DB 00H		;cltrgy idzts

;functions
RAJZOL: MVI A,62H	;put a picture, H:L=mem.addr.
OUT 00H
MVI C,50H
RCIKL: MOV A,M
OUT 00H
INX H
DCR C
JNZ RCIKL
RET

CDELAY: MVI C,20H	;cycle delay
CK1: PUSH B
MVI C,0FFH
CK2: NOP
NOP
NOP
NOP
NOP
DCR C
JNZ CK2
POP B
DCR C
JNZ CK1
RET

RESDLY: MVI C,10H	;result delay
CK3: PUSH B
CALL CDELAY
POP B
DCR C
JNZ CK3
RET

LOVO: MVI A,0EH		;lv mozog
OUT 00H
NOP
IN 00H
CPI 0AH
JZ SETLO
CPI 0DH
JZ MOVEL
CPI 0FH
JZ MOVER
RET
SETLO: NOP		;lvs indtsa
LDA LOVES
CPI 01H
RZ
MVI A,01H
STA LOVES
LDA LX
STA LOVX
MVI A,0FH
STA LOVY
CALL SOUND3
RET
MOVEL: CALL SOUND1	;move left
LDA LX
CPI 05H
RZ
DCR A
STA LX
MVI A,56H		;4X shift
OUT 00H
MVI A,13H
OUT 00H
MVI A,56H
OUT 00H
MVI A,12H
OUT 00H
MVI A,56H
OUT 00H
MVI A,11H
OUT 00H
MVI A,56H
OUT 00H
MVI A,10H
OUT 00H
RET
MOVER: CALL SOUND2	;move right
LDA LX
CPI 1AH
RZ
INR A
STA LX
MVI A,55H		;4X shift
OUT 00H
MVI A,13H
OUT 00H
MVI A,55H
OUT 00H
MVI A,12H
OUT 00H
MVI A,55H
OUT 00H
MVI A,11H
OUT 00H
MVI A,55H
OUT 00H
MVI A,10H
OUT 00H
RET

LO: LDA LOVES 		;lvs - lv l
CPI 01H
RNZ
MVI A,54H		;trs
OUT 00H
LDA LOVX
OUT 00H
LDA LOVY
OUT 00H
MVI A,00H
OUT 00H
LDA LOVY		;cskents
DCR A
STA LOVY
CPI 03H			;ellenrzs
JZ LCONTR
CPI 04H
JZ LCONTR
CPI 05H
JZ LCONTR
CPI 01H
JZ LOVEGE
RET
LCONTR: LDA LOVX
MOV B,A
LDA MX
DCR A
CMP B
JZ NYERT
INR A
CMP B
JZ NYERT
INR A
CMP B
JZ NYERT
RET
LOVEGE: MVI A,00H
STA LOVES
RET
NYERT: JMP HURRA	;nyers

MLO: LDA MLOVES		;lvs - MOZOG l
CPI 01H
RNZ
MVI A,54H		;trs
OUT 00H
LDA MLX
OUT 00H
LDA MLY
OUT 00H
MVI A,00H
OUT 00H
LDA MLY			;nvels
INR A
STA MLY
CPI 13H			;ellenrzs
JZ MLCONTR
CPI 12H
JZ MLCONTR
CPI 11H
JZ MLCONTR
RET
MLCONTR: LDA MLX
MOV B,A
LDA LX
DCR A
CMP B
JZ VESZTETT
INR A
CMP B
JZ VESZTETT
INR A
CMP B
JZ VESZTETT
LDA MLY
CPI 13H
JZ MLOVEGE
RET
MLOVEGE: MVI A,00H
STA MLOVES
RET
VESZTETT: JMP VESZT	;jtk elvesztse

MOZOG: LDA MDIR		;cltrgy mozog
CPI 01H
JZ BALRA
LDA MX			;jobbra mozgs
INR A
STA MX
CPI 1DH
JNZ JSHIFT
MVI A,01H
STA MDIR
JSHIFT: MVI A,55H	;jobbra shift
OUT 00H
MVI A,03H
OUT 00H
MVI A,55H
OUT 00H
MVI A,04H
OUT 00H
MVI A,55H
OUT 00H
MVI A,05H
OUT 00H
JMP L_HANDLE
BALRA: LDA MX		;balra mozgs
DCR A
STA MX
CPI 02H
JNZ BSHIFT
MVI A,02H
STA MDIR
BSHIFT: MVI A,56H	;balra shift
OUT 00H
MVI A,03H
OUT 00H
MVI A,56H
OUT 00H
MVI A,04H
OUT 00H
MVI A,56H
OUT 00H
MVI A,05H
OUT 00H
L_HANDLE: LDA MDLY	;lvedk kezelse - mozog l-e
INR A
STA MDLY
CPI 11H		;lvs idzts
JNZ NOLO
CALL SOUND4
MVI A,00H
STA MDLY
MVI A,01H
STA MLOVES
LDA MX
STA MLX
MVI A,06H
STA MLY
NOLO: LDA LOVES 	;lvedk kirajzolsa
CPI 01H
JNZ NOLO_1
MVI A,54H
OUT 00H
LDA LOVX
OUT 00H
LDA LOVY
OUT 00H
MVI A,01H
OUT 00H
NOLO_1: LDA MLOVES
CPI 01H
RNZ
MVI A,54H
OUT 00H
LDA MLX
OUT 00H
LDA MLY
OUT 00H
MVI A,01H
OUT 00H
RET

HURRA: NOP		;jtk megnyerse
CALL NOSOUND
LXI H,nyerstr
CALL STROUT
LXI H,hurrakep
CALL RAJZOL
CALL RESDLY
RSTGAME: NOP
CALL EFFECT
MVI H,0FFH
MVI L,0FFH
SPHL
MVI A,16H		;reinit
STA MX
MVI A,0FH
STA LX
MVI A,00H
STA LOVES
STA MLOVES
STA MDLY
MVI A,01H
STA MDIR
JMP START

VESZT: NOP		;jtk elvesztse
CALL NOSOUND
LXI H,vesztstr
CALL STROUT
LXI H,vesztkep
CALL RAJZOL
CALL RESDLY
JMP RSTGAME

STROUT: NOP		;Put a string to LCD, H:L=mem. addr.
MVI A,11H
OUT 00H
MVI A,03H
OUT 00H
MVI C,20H
STRCK: MOV A,M
OUT 00H
INX H
DCR C
JNZ STRCK
RET

EFFECT: MVI C,14H	;kperny effektus
PORCK: MVI A,57H
OUT 00H
PUSH B
CALL CDELAY
POP B
DCR C
JNZ PORCK
RET

SOUND1: MVI A,08H	;hang1
OUT 00H
MVI A,55H		;freq
OUT 00H
MVI A,00H
OUT 00H
RET

SOUND2: MVI A,08H	;hang2
OUT 00H
MVI A,70H		;freq
OUT 00H
MVI A,00H
OUT 00H
RET

SOUND3: MVI A,08H	;hang3
OUT 00H
MVI A,30H		;freq
OUT 00H
MVI A,00H
OUT 00H
RET

SOUND4: MVI A,08H	;hang3
OUT 00H
MVI A,0C1H		;freq
OUT 00H
MVI A,00H
OUT 00H
RET

NOSOUND: MVI A,09H
OUT 00H
RET

;---------------------------------------------------
;start game

START: NOP
MVI A,20H		;bip
OUT 00H
MVI A,53H		;clrscr
OUT 00H
MVI A,23H		;clrlcd
OUT 00H
LXI H,startstr
CALL STROUT
LXI H,startkep
CALL RAJZOL
GVAR: MVI A,0EH		;gombra vr
OUT 00H
NOP
IN 00H
CPI 00H
JZ GVAR
LXI H,runstr
CALL STROUT
LXI H,palyakep
CALL RAJZOL

STARTGAME: NOP		;gameciklus
CALL NOSOUND
CALL LOVO
CALL MOZOG
CALL CDELAY
CALL LO
CALL MLO
JMP STARTGAME


;data area

;PICTURES
startkep: DB 00H,00H,00H,00H
DB 00H,00H,00H,00H
DB 06H,49H,9CH,0C0H
DB 09H,49H,0D0H,0E0H
DB 08H,49H,50H,0A0H
DB 04H,49H,0DCH,0E0H
DB 06H,49H,90H,0C0H
DB 01H,49H,10H,0A0H
DB 09H,49H,10H,0B0H
DB 06H,79H,0CH,90H
DB 00H,00H,00H,00H
DB 00H,24H,00H,0A0H
DB 02H,18H,89H,0C0H
DB 02H,3CH,0DBH,0C0H
DB 02H,24H,52H,40H
DB 02H,24H,72H,40H
DB 02H,3CH,23H,0C0H
DB 03H,98H,21H,80H
DB 00H,00H,00H,00H
DB 00H,00H,00H,00H

palyakep: DB 00H,00H,00H,00H
DB 00H,00H,00H,00H
DB 00H,00H,0EH,00H
DB 00H,00H,0AH,00H
DB 00H,00H,0EH,00H
DB 00H,00H,00H,00H
DB 00H,00H,00H,00H
DB 00H,00H,00H,00H
DB 00H,00H,00H,00H
DB 00H,00H,00H,00H
DB 00H,00H,00H,00H
DB 00H,00H,00H,00H
DB 00H,00H,00H,00H
DB 00H,00H,00H,00H
DB 00H,00H,00H,00H
DB 00H,02H,00H,00H
DB 00H,07H,00H,00H
DB 00H,0DH,80H,00H
DB 00H,08H,80H,00H
DB 00H,00H,00H,00H

hurrakep: DB 00H,00H,00H,00H
DB 00H,00H,00H,00H
DB 00H,7cH,00H,00H
DB 00H,82H,00H,00H
DB 01H,01H,02H,20H
DB 02H,00H,81H,40H
DB 04H,48H,89H,10H
DB 04H,00H,84H,0A0H
DB 05H,02H,82H,40H
DB 04H,84H,82H,40H
DB 02H,78H,81H,80H
DB 03H,03H,01H,80H
DB 00H,0CCH,01H,80H
DB 00H,30H,03H,80H
DB 00H,00H,00H,00H
DB 00H,00H,00H,80H
DB 0AH,0AEH,0E7H,80H
DB 0EH,0AAH,0A4H,80H
DB 0AH,0ACH,0C7H,80H
DB 0AH,0EAH,0A4H,80H
DB 00H,00H,00H,00H

vesztkep:DB 00H,00H,00H,00H
DB 00H,00H,00H,00H
DB 00H,17H,0c0H,00H
DB 00H,20H,30H,00H
DB 00H,40H,08H,00H
DB 00H,40H,04H,00H
DB 00H,88H,44H,00H
DB 01H,10H,22H,00H
DB 01H,24H,92H,00H
DB 01H,0CH,0C1H,00H
DB 01H,00H,01H,00H
DB 01H,00H,01H,00H
DB 01H,00H,01H,00H
DB 00H,80H,01H,00H
DB 00H,87H,0C2H,00H
DB 00H,48H,42H,00H
DB 00H,20H,0CH,00H
DB 00H,1EH,70H,00H
DB 00H,01H,80H,00H
DB 00H,00H,00H,00H
DB 00H,00H,00H,00H

;LCD STRINGS
startstr: DB 	'L'
	DB 0EFH
	DB 'v'
	DB 0EFH
	DB ' jatek - BA PRESS A KEY     '
runstr:   DB 	'Super l'
	DB 0EFH
	DB 'v'
	DB 0EFH
	DB'      Quenne Electric '
nyerstr:  DB 	'Eljen nyert!    Super l'
	DB 0EFH
	DB 'v'
	DB 0EFH
	DB '      '
vesztstr: DB 	'Sajnos vesztett Super l'
	DB 0EFH
	DB 'v'
	DB 0EFH
	DB '      '

;////test
MVI A,51H
OUT 00H
LDA LX
OUT 00H
MVI A,50H
OUT 00H
;////test

END