;*************************************************
;**	BANDS SPECTRUM OPERATING SYSTEM 			**
;**	for PIC-I8085 MICROSYSTEM					**
;**	Copyright(c) Bognar Andras 2007 May			**
;*************************************************

	list	p=16f877A       ; Processzor  PIC16F877A
#include <P16f877A.inc>         ; processor header file

	__CONFIG 3F32h
	__IDLOCS 5555h          ; ID (azonosito)

	SSPCON1	EQU     H'0014'

	ORG 0
	nop
	clrf PCLATH
	goto sysinit

	ORG 0004H
INTERRUPT:
	movwf par13		;PUSH registers
	swapf STATUS,w
	clrf STATUS
	movwf par14
	movf PCLATH,w
	movwf par15
	clrf PCLATH
	movf FSR,w
	movwf FSRsav	;tovbb a par1..par7 hasznlata tilos!
	btfsc PIR1,RCIF
	goto RSvetel		;RS232 vtel
	btfsc PIR1,TMR1IF
	goto crtupdate		;kpernyfrissts IT
	btfsc PIR1,TMR2IF	;IT-ben csak par8..par15 a megengedett
	goto tim2		;hanggenerls IT
	goto itvege             ;INTFOLYT:;tovbbi IT ellenrzseket ide
itvege:	movf FSRsav,w		;POP registers
	movwf FSR
	movf par15,w
	movwf PCLATH
	swapf par14,w
	movwf STATUS
	swapf par13,f
	swapf par13,w
	retfie

;RENDSZER INICIALIZCI
sysinit:clrf PCLATH
	clrf STATUS		;bank0
	clrf testreg
	clrf PORTE
	bsf STATUS,RP0		;bank1
	movlw 0C7h
	movf OPTION_REG,f
	clrf INTCON		;disable ITs
	clrf PIE1
	clrf PIE2
	movlw 07h
	movf ADCON1,f
	clrf TRISC		;set PORT C
	clrf TRISE		;set PORT E
	clrf CVRCON		;Compare module off
	movlw 07h
	movwf CMCON		;Compare default
	movlw 07h		;A/D off
	movwf ADCON1
	clrf STATUS		;bank0
	clrf T1CON		;timer1 off
	clrf T2CON		;timer2 off
	clrf CCP1CON		;CCP off
	clrf CCP2CON
	clrf SSPCON1		;SSP off
	clrf RCSTA		;USART off
	clrf ADCON0		;AD off
	clrf PIR1
	clrf PIR2
;PERIFRIAKRTYA INICIALIZCI
	clrf STATUS		;billentyzet vltozk
	clrf OLD_KEY
	clrf A_KEY
	clrf spport		;soros port sttusz
	clrf sstate
	clrf STATUS		;perifria krtya init
	bsf STATUS,RP0
	clrf TRISC
	clrf TRISA
	clrf STATUS
	clrf PORTC
	clrf PORTA
	bsf PORTA,3
	clrf PORTD		;peripherial registers
	clrf PORTB
	movlw 0C5h
	movwf PORTD
	bsf PORTA,2
	call d5nop
	bcf PORTA,2
	movlw 30h
	movwf PORTB
	bsf PORTD,3
	bsf PORTA,2
	call d5nop
	bcf PORTA,2
	bcf PORTD,3
	bsf PORTA,2
	call d5nop
	bcf PORTA,2
;LCD INICIALIZCI:
	clrf STATUS		;bank0
	clrf PORTC		;LCD tri state er on
	bsf STATUS,RP0
	clrf TRISC
	movlw D'100'		;delay 20ms
	movwf par1
	movlw D'100'
	movwf par2
	call kes2
	movlw 38h		;function set
	call wr_com
	movlw D'250'		;delay 5ms
	movwf par1
	movlw D'10'
	movwf par2
	call kes2
	movlw 38h		;function set
	call wr_com
	movlw D'75'		;delay 150us
	movwf par1
	call kes1
	movlw 38h		;function set
	call wr_com
	movlw 38h		;function set
	call wr_com
	movlw 08h		;display off
	call wr_com
	movlw 01h		;clear display
	call wr_com
	call d2ms		;2ms delay
	movlw 06h		;entry mode set
	call wr_com
	movlw 0Ch		;display on
	call wr_com
	movlw 02h		;return home
	call wr_com
	call d2ms		;2ms delay
	;LCD-re kirs: Starting Band Spectrum
	movlw d'32'
	movwf par3
	movlw 0C0h
	movwf par1
	movlw 1Eh
	movwf par2
	movlw 20h
	call fstring
	movlw 3
	call lcdstr
;SOROS PORT INIT
	clrf STATUS
	bsf STATUS,RP0		;BANK1
	bsf TRISC,7
	movlw d'64'
	movwf SPBRG
	movlw H'66'
	movwf TXSTA
	movlw 0D0h
	bsf PIE1,RCIE
	clrf STATUS		;BANK0
	movwf RCSTA
;CRT TIMER1 INIT
	clrf STATUS		;BANK0
	movlw d'10'
	movwf FUGGL
	movlw d'239'
	movwf FUGGH
	clrf T1CON
	clrf TMR1H
	movf FUGGL,w
	movwf TMR1L
	movf FUGGH,w
	movwf TMR1H
	bcf PIR1,TMR1IF
	movlw 30h
	movwf T1CON
	bsf T1CON,TMR1ON
	bsf STATUS,RP0		;BANK1
	bsf PIE1,TMR1IE
	bsf INTCON,GIE		;enable ITs
	bsf INTCON,PEIE
	bsf PCLATH,3		;goto main program
	goto start

;minden bank-rl elrhet regiszterek paramterek (CALL hvskor paramtertadsra):
	par1 EQU 7Fh	;fggvnyparamterek a szolgltatsi rtegben: par1..par7
	par2 EQU 7Eh
	par3 EQU 7Dh
	par4 EQU 7Ch
	par5 EQU 7Bh
	par6 EQU 7Ah
	par7 EQU 79h
	par8 EQU 78h	;megszaktsi memriaterlet: par8..par15
	par9 EQU 77h
	par10 EQU 76h
	par11 EQU 75h
	par12 EQU 74h
	par13 EQU 73h
	par14 EQU 72h
	par15 EQU 71h
;vide paramter regiszterek (BANK3)
	pvid0 EQU 1EAh
	pvid1 EQU 1E9h
	pvid2 EQU 1E8h
	pvid3 EQU 1E7h
	pvid4 EQU 1E6h
	pvid5 EQU 1E5h
	pvid6 EQU 1E4h
	pvid7 EQU 1E3h
	pvid8 EQU 1E2h
	pvid9 EQU 1E1h

;SYSTEM VARIABLES rendszervltozk, s rsz.memriacmek amik csak a BANK0-rl rhetek el.
	OLD_KEY	EQU 20h	;elz lenyomott billenty
	A_KEY	EQU 21h ;billenty buffer
	spport 	EQU 22h ;soros port
	sstate  EQU 23h	;BIT0=1->sorosp. adhat, BIT1=1->vehet
	wtar	EQU 24h	;W reg. ideiglenes trhelye (azonnali parancs)
	RSdata 	EQU 25h	;RS232 vonal vteli trhelye (puffer)
	parity1	EQU 26h	;parits vizsglatnl hasznlva
	FSRsav	EQU 27h	;FSR regiszter mentse megszaktsban
	INTsav	EQU 28h	;INCON mentse (stack)
	FUGGL	EQU 29h ;fggleges visszatrtsi timer regiszterek
	FUGGH	EQU 30h
	wdatah	EQU 31h	;Winchester data high byte parameter
	state85	EQU 32h	;I8085 interface variable
	testreg	EQU 33h	;Tesztelsi regiszter
	PCsav	EQU 34h	;PCLATH save 
	s85		EQU 35h	;8085 ciklusok temp save reg.-e
	wdatal	EQU	36h	;Winchester data low
	wkes	EQU	37h	;Winchester delayer

	abszsor EQU 74h		;CRT sorok szma trhely (par12)
	repeat  EQU 75h		;CRT 1 sor ismtlse	 (par11)

;DELAYING
kes1:	nop		;IN: par1=ksleltets[us]/2
	nop		;2us-512us
	nop
	nop
	nop
	nop
	nop
	decfsz par1,f
	goto kes1
	return

kes2:	nop		;IN: ksleltets[us]=par1*2*par2+par2*0.2
	nop		;2us-131ms
	nop
	nop
	nop
	nop
	nop
	decfsz par1,f
	goto kes2
	decfsz par2,f
	goto kes2
	return

d10:	clrf STATUS	;kb 10 us delay
	movf INTCON,w
	movwf INTsav
	bcf INTCON,GIE
	movlw 05h
	movwf par1
	call kes1
	movf INTsav,w
	movwf INTCON
	return

d2ms:	clrf STATUS	;2ms delay
	movf INTCON,w
	movwf INTsav
	bcf INTCON,GIE
	movlw D'100'	;clear display+return home utn kell
	movwf par1
	movlw D'10'
	movlw par2
	call kes2
	movf INTsav,w
	movwf INTCON
	return

;LCD prifria kezels
;WRITING & READING THE LCD
wr_com:				;command write
	clrf STATUS		;w=command
	bsf STATUS,RP0		;bank1
	clrf TRISD
	clrf STATUS		;bank0
	movwf PORTD		;data out
	clrf PORTE
	call d10		;10 us delay
	movlw 02h
	movwf PORTE
	call d10		;10 us delay
	clrf PORTE
	movlw D'25'		;50 us delay
	movwf par1
	call kes1
	return

wr_data:			;write data
	clrf STATUS		;w=data
	bsf STATUS,RP0		;bank1
	clrf TRISD
	clrf STATUS		;bank0
	movwf PORTD		;data out
	movlw 04h
	movwf PORTE
	call d10		;10us delay
	movlw 06h
	movwf PORTE
	call d10		;10us delay
	movlw 04h
	movwf PORTE
	movlw D'25'		;50us delay
	movwf par1
	call kes1
	return

rd_data:			;read data
	clrf STATUS		;w=data
	bsf STATUS,RP0		;bank1
	clrf TRISD
	comf TRISD,f
	clrf STATUS		;bank0
	movlw 05h
	movwf PORTE
	call d10		;10us delay
	movlw 07h
	movwf PORTE
	movlw D'25'		;50us delay
	movwf par1
	call kes1
	movf PORTD,w		;kiolvas
	movlw 05h
	movwf PORTE
	call d10		;10us delay
	return

;LCD rutinok
lcd:	decf par1,f		;put a char to(X,Y) w=char,par1=X[1-16],par2=Y[1-2]
	movwf par3
	movlw 40h
	btfsc par2,1
	addwf par1,f
	bsf par1,7
	movf par1,w
	call wr_com
	call d10
	movf par3,w
	call wr_data
	call d10
	return

lcdolv:	decf par1,f		;get a char w=char,par1=x, par2=y
	movwf par3
	movlw 40h
	btfsc par2,1
	addwf par1,f
	bsf par1,7
	movf par1,w
	call wr_com
	call d10
	call rd_data
	movwf par3
	call d10
	movf par3,w
	return

lcdstr:	movwf par4		;Update LCD from LCD buffer, LCD buffer=BANK1 20H-40H
	btfsc par4,0		;w=mode: 1-1.sor, 2-2.sor, 3-mindkt sor
	goto line1
vissza1:
	btfsc par4,1
	goto line2
	return
line1:movlw d'16'		;line1
	movwf par3		;cikl. szmll
	clrf STATUS
	movlw 0A0h		;forrs memriacm
	movwf FSR
	clrf par2		;LCD memriaszmll + parancs
	bsf par2,7
lcd_cikl1:
	movf par2,w
	call wr_com
	incf par2,f
	call d10
	movf INDF,w
	incf FSR,f
	call wr_data
	call d10
	decfsz par3,f
	goto lcd_cikl1
	goto vissza1
line2:	movlw d'16'		;line2
	movwf par3		;cikl.szmll
	clrf STATUS
	movlw 0B0		;forrs cme
	movwf FSR
	clrf par2		;LCD mem parancs
	bsf par2,7
	bsf par2,6
lcd_cikl2:
	movf par2,w
	call wr_com
	incf par2,f
	call d10
	movf INDF,w
	incf FSR,f
	call wr_data
	call d10
	decfsz par3,f
	goto lcd_cikl2
	return

clrlcd:	movlw 1			;LCD trlse
	call wr_com
	call d2ms
	return

;BILLENTYKEZELS:
bill:bcf INTCON,GIE
	call bill1		;Azrt kell hogy vissza is lltsa az LCD-t a rutin
	clrf PORTC		;LCD visszalltsa, billentycsatorna zrsa
	bsf INTCON,GIE
	return
bill1:				;w=scan code
	clrf STATUS		;w=0 ha nincs lenyomva semmi
	btfsc sstate,3
	retlw 0
	bsf STATUS,RP0		;bank1
	movlw 0AAh
	movwf TRISD
	clrf STATUS		;bank0
	movlw 01h
	movwf PORTC		;ideiglenes vlts PORTC-t megvltoztatja!
	call d10
	movlw 0FEh		;oszlopvlts
	movwf PORTD
	call d10
	btfss PORTD,7
	retlw 1
	btfss PORTD,5
	retlw 2
	btfss PORTD,3
	retlw 3
	btfss PORTD,1
	retlw 4
	movlw 0FBh		;oszlopvlts
	movwf PORTD
	call d10
	btfss PORTD,7
	retlw 5
	btfss PORTD,5
	retlw 6
	btfss PORTD,3
	retlw 7
	btfss PORTD,1
	retlw 8
	movlw 0EFh		;oszlopvlts
	movwf PORTD
	call d10
	btfss PORTD,7
	retlw 9
	btfss PORTD,5
	retlw D'10'
	btfss PORTD,3
	retlw D'11'
	btfss PORTD,1
	retlw D'12'
	movlw 0BFh		;oszlopvlts
	movwf PORTD
	call d10
	btfss PORTD,7
	retlw D'13'
	btfss PORTD,5
	retlw D'14'
	btfss PORTD,3
	retlw D'15'
	btfss PORTD,1
	retlw D'16'
	retlw 0

kbhit:	call bill		;kbhit() fggvny: folyamatos bill. nyoms elvetsvel
	movwf A_KEY		;w=lenyomott billenty
	subwf OLD_KEY,w
	btfsc STATUS,Z
	goto ugyanaz
	movf A_KEY,w
	movwf OLD_KEY
	return
ugyanaz:
	retlw 00h

;SOROS PORT lekezelse   19200bps 1stop bit,pros parity, 8BIT
RSvetel:		;INTERRUPT rutinrszlet
	clrf STATUS
	movf RCREG,w		;adat kiolvass
	movwf RSdata
	movwf parity1
	bsf sstate,1		;SET jtt adat bit 
	bcf sstate,2
	btfsc RCSTA,FERR
	goto serror
	btfsc RCSTA,OERR
	goto serror
	call parity			;parits vizsglat
	btfss RCSTA,RX9D
	goto paratlan
	btfss parity1,0
	goto serror
	goto stvar
paratlan:
	btfsc parity1,0
	goto serror
	goto stvar
serror:	movlw 01h
	clrf STATUS 		;SET hibajelzs bit
	bsf sstate,2
stvar:
	btfsc PIR1,RCIF		;megvrjuk mg magtol trldik a FLAG
	goto stvar
	goto itvege

resetport:			;visszalls parancsportba
	clrf STATUS
	clrf spport
	return

send:	clrf STATUS		;send a char to RS232  W=char to send
	bsf spport,0
	movwf par1
	movwf parity1
var1:	btfss PIR1,TXIF	;wait last data
	goto var1
	call parity
	bsf STATUS,RP0
	bcf TXSTA,TX9D
	clrf STATUS
	btfss parity1,0
	goto par0
	bsf STATUS,RP0
	bsf TXSTA,TX9D
par0:	clrf STATUS
	movf par1,w
	movwf TXREG
	return

receive:clrf STATUS		;vtel RS232rl  w=vett
	bsf spport,0        ;W=vett adat
	bsf STATUS,RP0		;BANK1
	bcf PIE1,TMR1IE		;timer1 tiltsa
	bsf INTCON,GIE
	clrf STATUS			;BANK0
var2:	btfss sstate,1		;Addig vr mg nem jn adat! OUT: 
	goto var2
	bcf INTCON,GIE
	bsf STATUS,RP0		;BANK1
	bsf PIE1,TMR1IE		;timer1 eng.
	clrf STATUS			;BANK0
	bcf sstate,1
	movf RSdata,w
	return

parity:	;pros parits IN:parity1, OUT parity1 -OFFh pros p. -00h nem pros p.
	movlw 00h		;szmll=w
	btfsc parity1,0
	addlw 1
	btfsc parity1,1
	addlw 1
	btfsc parity1,2
	addlw 1
	btfsc parity1,3
	addlw 1
	btfsc parity1,4
	addlw 1
	btfsc parity1,5
	addlw 1
	btfsc parity1,6
	addlw 1
	btfsc parity1,7
	addlw 1
	movwf parity1
	movlw 0FFh
	btfss parity1,0
	movlw 00h
	movwf parity1
	return

;HIBAKEZELS
errorm:	movwf par6		;w=errno [0..9]
	movlw d'32'		;szveg->RAM
	movwf par3
	movlw 1eh		;flash fels cm
	movwf par2
	movlw 0E0h		;flash als cm
	movwf par1
	movlw 20h
	call fstring		;szveg beolv.
	movlw 3
	call lcdstr		;kiirats: ERROR 12 Press Any key
	movlw d'48'
	addwf par6,f
	movlw d'8'		;X coord
	movwf par1
	movlw d'1'		;Y coord
	movwf par2
	movf par6,w
	call lcd		;Errno
	call bip
	call d2ms
	return

;PWM AND SOUND     ! Brmelyiket is lltjuk, a msik ellltdik!
;Egyszerre a PWM s a SOUND nem hasznlhat!
;!!!!!!!!!!!A PWM RSZ NEM MKDIK CSAK A HANG!!!!!!!!!!!!!!!
pwm:	;PWM1 kimeneten pwm jel kiadsa  par1=Tperiod, par3(MSB 2BIT):par2=Tdutycycle
	clrf STATUS
	clrf CCP1CON
	clrf CCP2CON
	bsf STATUS,RP0
	movf par1,w
	movwf PR2
	bcf PIE1,TMR2IE		;IT-s hanggen kikapcs.
	clrf STATUS		;par3:par2=>CCPR1L(8bit):CCP1CON(LSB 2bit)
	rrf par3,f
	rrf par2,f
	clrf par5
	rrf par5,f
	rrf par3,f
	rrf par2,w
	rrf par5,f
	movwf CCPR1L
	rrf par5,f
	rrf par5,w
	iorlw 0Fh
	movwf CCP1CON
	bsf STATUS,RP0
	bcf TRISC,2
	clrf STATUS
	clrf TMR2
	movlw 7Fh 		;(76Hz)
	movwf T2CON
	return

sound:	movwf par2		;w=freq no., par1[bit0]=1 esetn 16-os oszts bekapcs.
	comf par2,w
	comf par2,f
	clrf STATUS
	bsf STATUS,RP0
	movwf PR2
	bcf STATUS,C
	rrf par2,f		;duty(/2)
	clrf par5
	clrf STATUS
	bcf STATUS,C
	rrf par2,f
	rrf par5,f
	rrf par2,f
	rrf par5,f
	rrf par5,f
	rrf par5,w
	iorlw 0Fh
	movwf CCP2CON
	movf par2,w
	andlw 3Fh
	movwf CCPR2L
	bsf STATUS,RP0	
	bcf TRISC,1
	clrf STATUS
	clrf TMR2
	movlw 7Fh		;min 76Hz
	movwf T2CON		;76Hz alatt megszaktsos idzts
	bsf STATUS,RP0
	bcf PIE1,TMR2IE		;IT-s hanggen kikapcs.
	btfss par1,0
	return
	clrf STATUS             ;Interruptos hanggenerls pa1[0]=1 esetn
	clrf CCP2CON            ;CCP lelltsa
	bsf STATUS,RP0		;set TMR-IT
	bsf PIE1,TMR2IE
	return

nosound:clrf STATUS		;sound off
	bsf STATUS,RP0
	bcf PIE1,TMR2IE		;IT-s hanggen kikapcs.
	bsf TRISC,1
	return

pwmoff:	clrf STATUS		;PWM off
	bsf STATUS,RP0
	bsf TRISC,2
	return

bip:	clrf par1		;Csippans (jelzs, hibajelzs)
	movlw d'120'
	call sound
	movlw d'10'
	movwf par3
bipcikl:movlw d'250'
	movwf par1
	movlw d'2'
	movwf par2
	call kes2
	decfsz par3,f
	goto bipcikl
	call nosound
	return

tim2:	;INTERRUPT: Interruptos hangkelts
	clrf STATUS
	bcf PIR1,TMR2IF
	btfss PORTC,1
	goto sndclr
	bcf PORTC,1
	goto sndfly
sndclr:	bsf PORTC,1
sndfly: goto itvege

;A/D CONVERTER  (from RA0)
adcon:	clrf STATUS
	bsf STATUS,RP0
	bsf TRISA,0
	movlw 04h
	movwf ADCON1
	clrf STATUS
	movlw 0C1h
	movwf ADCON0
	call d2ms
	bsf ADCON0,2
var_ad:	btfsc ADCON0,2
	goto var_ad
	clrf STATUS
	movf ADRESH,w		;data->par1:par2
	movwf par1
	bsf STATUS,RP0
	movf ADRESL,w
	movwf par2
	clrf STATUS
	clrf ADCON0			;stop A/D
	bsf STATUS,RP0
	bsf ADCON1,2
	bsf ADCON1,1
	return

;data EEPROM reading/writing
eeread:				;data EEPROM reading
	bsf STATUS,RP1		;IN:W=address, OUT:W=data
	bcf STATUS,RP0
	movwf EEADR
	bsf STATUS,RP0
	bcf EECON1,EEPGD
	bsf EECON1,RD
	bcf STATUS,RP0
	movf EEDATA,W
	clrf STATUS
	return

eewrite:      			;data EEPROM writing
	bsf STATUS,RP1		;W=data, par1=address
	bsf STATUS,RP0
eevar:	btfsc EECON1,WR
	goto eevar
	bcf STATUS,RP0
	movwf EEDATA
	movf par1,w
	movwf EEADR
	bsf STATUS,RP0
	bcf EECON1,EEPGD
	bsf EECON1,WREN
	;bcf INTCON,GIE;!
	movlw 55h
	movwf EECON2
	movlw 0AAh
	movwf EECON2
	bsf EECON1,WR
	;bsf INTCON,GIE;!
	bcf EECON1,WREN
	return

;FLASH programmemria rsa/kiolvassa
flashr:	bsf STATUS,RP1		;Flash program mem. read.
	bcf STATUS,RP0		;[par2:par1]->par2:par1
	movf par1,w
	movwf EEADR
	movf par2,w
	movwf EEADRH
	bsf STATUS,RP0
	bsf EECON1,EEPGD
	bsf EECON1,RD
	nop
	nop
	bcf STATUS,RP0
	movf EEDATA,w
	movwf par1
	movf EEDATH,w
	movwf par2
	return

flashw:	bsf STATUS,RP1		;Flash program mem. write
	bcf STATUS,RP0		;par2:par1->[par4:par3]
	movf par3,w
	movwf EEADR
	movf par4,w
	movwf EEADRH
	movf par1,w
	movwf EEDATA
	movf par2,w
	movwf EEDATH
	bsf STATUS,RP0
	bsf EECON1,EEPGD
	bsf EECON1,WREN
	bcf INTCON,GIE
	movlw 55h
	movwf EECON2
	movlw 0AAh
	movwf EECON2
	bsf EECON1,WR
	nop
	nop
	bsf INTCON,GIE
	bcf EECON1,WREN
	return

fstring:movwf FSR		;string olvassa ROM->RAM
	clrf STATUS		;par3=hossz [par2:par1]- >[bank1:w]
	bsf FSR,7
	bcf STATUS,IRP
	movf par2,w		;[par2:par1]->[par5:par4]
	movwf par5
	movf par1,w
	movwf par4
fcikl:	movf par5,w		;[par5:par4]->[par2:par1]
	movwf par2
	movf par4,w
	movwf par1
	call flashr
	movf par1,w
	movwf INDF
	incf FSR,f
	incfsz par4,f
	goto fug1
	incf par5,f
fug1:	decfsz par3,f
	goto fcikl
	return

;CRT kezels, fciklus
;timer0 megszaktsos idzts fggleges visszafutshoz, sorsznetekben timer2 letiltva
;INTERRUPT
crtupdate:			;TMR1 idzt megszaktsa
	clrf STATUS
	btfsc sstate,3		;CRT lelltva?
	goto nocrt
	bsf STATUS,RP0
	clrf TRISB
	clrf TRISD
	clrf STATUS
	clrf PORTC		;Billentyzet s LCD kikapcs.
	bcf PORTE,0
	bcf T1CON,TMR1ON	;TMR1 OFF
	bcf PORTA,2		;kpszinkron lefut (=0)
	movlw 31h
	movwf PORTB
	movlw 0C5h
	movwf PORTD
	bsf PORTD,3
	bsf PORTA,2
	nop
	bcf PORTA,2
	bcf PORTD,3
	bsf PORTA,2
	nop
	bcf PORTA,2

	call elodelay		;elksleltets (esetleg)
	clrf STATUS			;res sorok(5 db)
	bsf STATUS,IRP		;! indirekt cmzs
	movlw d'20'			;init
	movwf abszsor
	movlw d'10'
	movwf repeat
	movlw 90h			;videram kezd cme
	movwf FSR
	call sorvissza		;res sorok
	call d1sor
	call sorvissza
	call d1sor
	call sorvissza
	call d1sor
nextsor:call sorvissza		;sorciklus
	call hanggen
	call hanggen
	call hanggen
	bcf PORTC,5     	;aktv l 1
	bsf PORTC,5
	bsf STATUS,IRP
	movf INDF,w
	incf FSR,f
	movwf PORTB
	call hanggen
	call d5nop
	call hanggen
	call d5nop
	nop
	nop
	nop
	call hanggen
	bcf PORTC,5     	;aktv l 2
	bsf PORTC,5
	bsf STATUS,IRP
	movf INDF,w
	incf FSR,f
	movwf PORTB
	call hanggen
	call d5nop
	call hanggen
	call d5nop
	nop
	nop
	nop
	call hanggen
	bcf PORTC,5     	;aktv l 3
	bsf PORTC,5
	bsf STATUS,IRP
	movf INDF,w
	incf FSR,f
	movwf PORTB
	call hanggen
	call d5nop
	call hanggen
	call d5nop
	nop
	nop
	nop
	call hanggen
	bcf PORTC,5     	;aktv l 4
	bsf PORTC,5
	call d5nop
	call d5nop
	decfsz repeat,f		;soradminisztrci
	goto repeat1
	movlw d'10'
	movwf repeat
	decfsz abszsor,f
	goto nextsor
	goto endrefresh
repeat1:movlw 4     		;FSR cskkentse 4-el
	subwf FSR,f
	goto nextsor

elodelay: nop			;res sorok eltti elksleltets
	;Ksleltet rutint ide
	return

d5nop:	nop			;1us delay
	return

d1sor:	movlw d'31'		;51.2us (256 cycle) azaz 1 sor delay
	movwf par10
cd1sor: call d5nop
	decfsz par10,f
	goto cd1sor
	nop
	bcf PORTD,1
	decf FSR,f
	return

sorvissza:			;sorvisszafuttats
	movlw 31h
	movwf PORTB
	movlw 0C5h
	movwf PORTD
	nop
	nop
	nop
	nop
	bsf PORTB,7
	bsf PORTD,3
	call d5nop
	bsf PORTA,2	     	;felfuts
	nop
	nop
	nop
	bcf PORTA,2
	bcf PORTD,3
	bsf PORTA,2
	call d5nop
	bcf PORTA,2
	call d5nop
	bcf PORTB,7
	bsf PORTD,3
	call d5nop
	bsf PORTA,2		;lefuts
	nop
	nop
	nop
	bcf PORTA,2
	bcf PORTD,3
	nop
	nop
	nop
	bsf PORTA,2
	nop
	nop
	bcf PORTA,2
	bsf STATUS,IRP
	movf INDF,w
	incf FSR,f
	movwf PORTB
	nop
	nop
	nop
	return

hanggen:clrf STATUS		;hanggenerlsos ksleltets
	btfss PIR1,TMR2IF
	goto nomatch
	bcf PIR1,TMR2IF
	btfss PORTC,1
	goto sndclr1
	nop
	bcf PORTC,1
	goto sndfly1
sndclr1:bsf PORTC,1
	goto sndfly1
nomatch:call d5nop
	nop
sndfly1:nop
	return

endrefresh:        		;CRT IT elhagysa
	clrf STATUS		;Fggleges visszafuts
	movlw 31h		;felfut(=1)
	movwf PORTB
	movlw 0C5h
	movwf PORTD
	bsf PORTB,6
	bsf PORTD,3
	call d5nop
	bsf PORTA,2
	call d5nop
	bcf PORTA,2
	bcf PORTD,3
	bsf PORTA,2
	call d5nop
	bcf PORTA,2
nocrt:
	call parancs		;azonnali parancs lekezelse
	clrf STATUS
	movf FUGGL,w		;timer1 reset
	movwf TMR1L
	movf FUGGH,w
	movwf TMR1H
	bcf PIR1,TMR1IF
	bsf T1CON,TMR1ON
	goto itvege

;Vide memria kezel rutinok (BANK3:190H-tl 80byte)
clrscr:			;kperny trls
	movlw d'80'
	movwf par1	;counter
	movlw 90h
	movwf FSR
clrcikl:bsf STATUS,IRP
	clrf INDF
	incf FSR,f
	decfsz par1,f
	goto clrcikl
	return

putpixel:		;(X,Y)-ba teszi: par1=X, par2=Y, par3=COLOR
	;X[1..32], Y[1..20], COLOR[0..1]
	decf par2,f   	;(y-1)*4
	bcf STATUS,C
	rlf par2,f
	bcf STATUS,C
	rlf par2,f
	movf par1,w
	movwf par4
	decf par1,f	;(x-1)/8
	bcf STATUS,C
	rrf par1,f
	bcf STATUS,C
	rrf par1,f
	bcf STATUS,C
	rrf par1,w
	addwf par2,f	;byte cm
	movlw 07h
	andwf par4,f
	btfsc STATUS,Z
	bsf par4,3
	movlw 80h
	movwf par1
shck:	decfsz par4,f
	goto shckm
	goto fly2
shckm:	bcf STATUS,C
	rrf par1,f
	goto shck
fly2:	btfss par3,0
	goto rstpix
	movlw 90h	;set pixel
	addwf par2,w
	bsf STATUS,IRP	;190h
	movwf FSR
	movf par1,w
	iorwf INDF,f
	return
rstpix:	movlw 90h	;reset pixel
	addwf par2,w
	bsf STATUS,IRP	;190h
	movwf FSR
	comf par1,w
	andwf INDF,f
	return

shiftr:			;shift right par1=sor[1..20]
	decf par1,f
	bcf STATUS,C
	rlf par1,f
	bcf STATUS,C
	rlf par1,f
	movlw 90h
	addwf par1,w
	movwf FSR
	bsf STATUS,IRP
	bcf STATUS,C
	rrf INDF,f
	incf FSR,f
	rrf INDF,f
	incf FSR,f
	rrf INDF,f
	incf FSR,f
	rrf INDF,f
	return

shiftl:			;shift left par1=sor[1..20]
	decf par1,f
	bcf STATUS,C
	rlf par1,f
	bcf STATUS,C
	rlf par1,f
	movlw 93h
	addwf par1,w
	movwf FSR
	bsf STATUS,IRP
	bcf STATUS,C
	rlf INDF,f
	decf FSR,f
	rlf INDF,f
	decf FSR,f
	rlf INDF,f
	decf FSR,f
	rlf INDF,f
	return

shiftu:			;shift up whole CRT
	movlw d'19'
	movwf par1
	bsf STATUS,RP0
	bsf STATUS,RP1
	movf 190h,w	;90h!
	movwf par2
	movf 191H,w
	movwf par3
	movf 192H,w
	movwf par4
	movf 193H,w
	movwf par5
	movlw 90h
	movwf FSR
	bsf STATUS,IRP
uck:	movlw 4
	addwf FSR,f
	movf INDF,w
	movwf par6
	movlw 4
	subwf FSR,f
	movf par6,w
	movwf INDF
	incf FSR,f		;macro6
	movlw 4
	addwf FSR,f
	movf INDF,w
	movwf par6
	movlw 4
	subwf FSR,f
	movf par6,w
	movwf INDF
	incf FSR,f		;macro6
	movlw 4
	addwf FSR,f
	movf INDF,w
	movwf par6
	movlw 4
	subwf FSR,f
	movf par6,w
	movwf INDF
	incf FSR,f		;macro6
	movlw 4
	addwf FSR,f
	movf INDF,w
	movwf par6
	movlw 4
	subwf FSR,f
	movf par6,w
	movwf INDF
	incf FSR,f
	decfsz par1,f
	goto uck
	movf par2,w
	movwf 1DCh
	movf par3,w
	movwf 1DDh
	movf par4,w
	movwf 1DEh
	movf par5,w
	movwf 1DFh
	return

shiftd:			;shift doen whole CRT
	movlw d'19'
	movwf par1
	bsf STATUS,RP0
	bsf STATUS,RP1
	movf 1DCh,w
	movwf par2
	movf 1DDh,w
	movwf par3
	movf 1DEh,w
	movwf par4
	movf 1DFh,w
	movwf par5
	movlw 1DFh
	movwf FSR
	bsf STATUS,IRP
dck:	movlw 4		;macro7
	subwf FSR,f
	movf INDF,w
	movwf par6
	movlw 4
	addwf FSR,f
	movf par6,w
	movwf INDF
	decf FSR,f
	movlw 4		;macro7
	subwf FSR,f
	movf INDF,w
	movwf par6
	movlw 4
	addwf FSR,f
	movf par6,w
	movwf INDF
	decf FSR,f
	movlw 4		;macro7
	subwf FSR,f
	movf INDF,w
	movwf par6
	movlw 4
	addwf FSR,f
	movf par6,w
	movwf INDF
	decf FSR,f
	movlw 4		;macro7
	subwf FSR,f
	movf INDF,w
	movwf par6
	movlw 4
	addwf FSR,f
	movf par6,w
	movwf INDF
	decf FSR,f
	decfsz par1,f
	goto dck
	movf par2,w
	movwf 90h
	movf par3,w
	movwf 91h
	movf par4,w
	movwf 92h
	movf par5,w
	movwf 93h
	return

;WINCHESTER RUTINOK
winit:	;initialize winchester (1. LATCH=0C5H)
	bcf INTCON,GIE		;reset kiadsa
	clrf STATUS
	clrf wdatah
	bsf STATUS,RP0
	clrf TRISD
	clrf TRISB
	clrf STATUS
	movlw 0C5h
	movwf PORTD
	movlw 30h
	movwf PORTB
	bcf PORTA,2
	bsf PORTA,2
	bcf PORTA,2
	bcf PORTB,0
	bsf PORTD,3
	bsf PORTA,2
	bcf PORTA,2
	bcf PORTD,3
	bsf PORTA,2
	bcf PORTA,2
	call d5nop
	bsf PORTB,0
	bsf PORTD,3
	bsf PORTA,2
	bcf PORTA,2
	bcf PORTD,3
	bsf PORTA,2
	bcf PORTA,2
	bsf INTCON,GIE
;kesleltetes 3s
	bcf INTCON,GIE
	movlw d'30'
	movwf par3
wkes3:
	movlw 0FFh
	movwf par1
	movwf par2
wkes2:	nop
	nop
	nop
	nop
	nop
	nop
	nop
	decfsz par1,f
	goto wkes2
	decfsz par2,f
	goto wkes2
	decfsz par3
	goto wkes3
	bsf INTCON,GIE
	return

wregw:		;winch. reg. rs  par1=address, wdatah:w=data
	movwf par2
	bcf INTCON,GIE
	clrf STATUS
	movlw 31h
	movwf PORTB
	movlw 0C5h
	movwf PORTD
	btfsc par1,0		;cmkiads
	bsf PORTB,2
	btfsc par1,1
	bsf PORTB,3
	btfsc par1,2
	bsf PORTB,1
	bsf PORTD,3		;cmstrobe
	bsf PORTA,2
	bcf PORTA,2
	bcf PORTD,3
	bsf PORTA,2
	bcf PORTA,2
	bsf PORTD,4		;BALE strobe
	bsf PORTA,2
	bcf PORTA,2
	bcf PORTD,4
	bsf PORTA,2
	bcf PORTA,2
	movf wdatah,w		;macro12: datah kivitele (data HIGH)
	movwf PORTB
	bsf PORTD,5
	bsf PORTA,2
	bcf PORTA,2
	bcf PORTD,5
	bsf PORTA,2
	bcf PORTA,2
	movf par2,w		;data OUT
	movwf PORTB
	bsf PORTD,1
	bcf PORTD,2
	bsf PORTA,2
	bcf PORTA,2
	bcf PORTD,0		;data strobe
	bsf PORTA,2		;-IOW strobe
	bcf PORTA,2
	nop
	nop
	bsf PORTD,0
	bsf PORTA,2
	bcf PORTA,2
	nop
	nop
	bsf PORTD,2
	bsf PORTA,2
	bcf PORTA,2
	bsf INTCON,GIE
	return

wregr:		;winch. reg olvass  par1=address, wdatah:w=data
	movwf par2
	bcf INTCON,GIE
	clrf STATUS
	movlw 31h
	movwf PORTB
	movlw 0C5h
	movwf PORTD
	btfsc par1,0		;cmkiads
	bsf PORTB,2
	btfsc par1,1
	bsf PORTB,3
	btfsc par1,2
	bsf PORTB,1
	bsf PORTD,3		;cmstrobe
	bsf PORTA,2
	bcf PORTA,2
	bcf PORTD,3
	bsf PORTA,2
	bcf PORTA,2
	bsf PORTD,4		;BALE strobe
	bsf PORTA,2
	bcf PORTA,2
	bcf PORTD,4
	bsf PORTA,2
	bcf PORTA,2
	bsf PORTA,5		;-IOR lefut
	bsf STATUS,RP0	;read data
	movlw 0FFh
	movwf TRISB
	clrf STATUS
	bcf PORTD,2
	bsf PORTA,2
	bcf PORTA,2
	nop
	nop
	nop
	movf PORTB,w
	movwf par1
	bsf PORTD,2
	bsf PORTA,2
	bcf PORTA,2
	bcf PORTD,6		;read data HIGH
	bsf PORTA,2
	bcf PORTA,2
	movf PORTB,w
	movwf wdatah
	bsf STATUS,RP0
	clrf TRISB
	clrf STATUS
	bsf PORTD,6
	bsf PORTA,2
	bcf PORTA,2
	bcf PORTA,5		;-IOR felfut
	movf par1,w
	return

w_wrcom:	;winchester rsi parancs kiadsa
		;par3=SEC, par4=CYLL, par5=CYLH, par6=HD
		;OUT: par7=0->OK, =FF->hiba
	movlw 6
	movwf par1
	movlw 0A0h
	call wregw
wvar1:	movlw 7		;kszenlt megvr  (!STATUS)
	movwf par1
	call wregr
	movwf par1
	btfss par1,6
	goto wvar1
	movlw 01h
	movwf par1
	movlw 0FFh
	call wregw
	movlw 02h
	movwf par1
	movlw 01h
	call wregw
	movlw 03h
	movwf par1
	movf par3,w
	call wregw
	movlw 04h
	movwf par1
	movf par4,w
	call wregw
	movlw 05h
	movwf par1
	movf par5,w
	call wregw
	movlw 06h
	movwf par1
	movlw 0Fh
	andwf par6,w
	iorlw 0A0h
	call wregw
	movlw 07h
	movwf par1
	movlw 30h
	call wregw
wvar2:	movlw 07h		;(!STATUS)  (IT vrs)
	movwf par1		;adatbevitel krse
	call wregr
	movwf par1
	btfss par1,3
	goto wvar2
	movlw 0FFh
	movwf par7
	btfss par1,0
	clrf par7
	return

w_rcom:		;winchester olvassi parancs kiadsa
		;par3=SEC, par4=CYLL, par5=CYLH, par6=HD
		;OUT: par7=0->OK, =FF->hiba
	movlw 6
	movwf par1
	movlw 0A0h
	call wregw
wvar5:	movlw 7		;kszenlt megvr  (!STATUS)
	movwf par1
	call wregr
	movwf par1
	btfss par1,6
	goto wvar5
	movlw 01h
	movwf par1
	movlw 0FFh
	call wregw
	movlw 02h
	movwf par1
	movlw 01h
	call wregw
	movlw 03h
	movwf par1
	movf par3,w
	call wregw
	movlw 04h
	movwf par1
	movf par4,w
	call wregw
	movlw 05h
	movwf par1
	movf par5,w
	call wregw
	movlw 06h
	movwf par1
	movlw 0Fh
	andwf par6,w
	iorlw 0A0h
	call wregw
	movlw 07h
	movwf par1
	movlw 20h
	call wregw
wvar3:	movlw 07h		;(!STATUS)
	movwf par1
	call wregr
	movwf par1
	btfss par1,3
	goto wvar3
	movlw 0FFh
	movwf par7
	btfss par1,0
	clrf par7
	return




;PARANCSVTEL RS232-n t host szmtgprl
;parancs interpreter
parancs:clrf STATUS
	btfsc spport,0		;parancsport-e ?
	return
	btfss sstate,1		;jtt-e adat?
	return
	movf par1,w		;paramterek mentse
	movwf par11
	movf par2,w
	movwf par12
	call receive
	movwf par10
	call send			;parancs visszaklds
	btfss sstate,2		;error?
	goto vetelok
	call bip		;error
	movlw H'ff'		;hibakd klds 3X
	call send
	movlw H'ff'
	call send
	movlw H'ff'
	call send
	call resetport
	movf par11,w		;restore parameters
	movwf par1
	movf par12,w
	movwf par2
	return
vetelok:movlw H'01'		;COMMAND INTERPRETER
	subwf par10,w 		;rendszer fggvny hvsok
	btfsc STATUS,Z
	goto portwrite
	movlw H'02'
	subwf par10,w
	btfsc STATUS,Z
	goto portread
	movlw H'03'
	subwf par10,w
	btfsc STATUS,Z
	goto stop
	movlw H'04'
	subwf par10,w
	btfsc STATUS,Z
	goto continue
	movlw H'05'
	subwf par10,w
	btfsc STATUS,Z
	goto writemem
	movlw H'06'
	subwf par10,w
	btfsc STATUS,Z
	goto readmem
	movlw H'07'
	subwf par10,w
	btfsc STATUS,Z
	goto reset
	movlw H'18'
	subwf par10,w
	btfsc STATUS,Z
	goto wwrite
	movlw H'19'
	subwf par10,w
	btfsc STATUS,Z
	goto wread
	movf par11,w		;restore parameters
	movwf par1
	movf par12,w
	movwf par2
	movlw H'08'		;Szolgltat fggvnyek hvsa
	subwf par10,w
	btfsc STATUS,Z
	goto _sound
	movlw H'09'
	subwf par10,w
	btfsc STATUS,Z
	goto _nosound
	movlw H'0B'
	subwf par10,w
	btfsc STATUS,Z
	goto _pwm
	movlw H'0C'
	subwf par10,w
	btfsc STATUS,Z
	goto _pwmoff
	movlw H'0D'
	subwf par10,w
	btfsc STATUS,Z
	goto _lcd
	movlw H'0E'
	subwf par10,w
	btfsc STATUS,Z
	goto _bill
	movlw H'0F'
	subwf par10,w
	btfsc STATUS,Z
	goto _kbhit
	movlw H'10'
	subwf par10,w
	btfsc STATUS,Z
	goto _lcdolv
	movlw H'11'
	subwf par10,w
	btfsc STATUS,Z
	goto _lcdstr
	movlw H'12'
	subwf par10,w
	btfsc STATUS,Z
	goto _flashr
	movlw H'13'
	subwf par10,w
	btfsc STATUS,Z
	goto _eewrite
	movlw H'14'
	subwf par10,w
	btfsc STATUS,Z
	goto _eeread
	movlw H'15'
	subwf par10,w
	btfsc STATUS,Z
	goto _fstring
	movlw H'16'
	subwf par10,w
	btfsc STATUS,Z
	goto _error
	movlw H'17'
	subwf par10,w
	btfsc STATUS,Z
	goto _adcon
	movlw H'20'
	subwf par10,w
	btfsc STATUS,Z
	goto _bip
	movlw H'21'
	subwf par10,w
	btfsc STATUS,Z
	goto _flashw
	movlw H'23'
	subwf par10,w
	btfsc STATUS,Z
	goto _clrlcd
	movlw H'25'
	subwf par10,w
	btfsc STATUS,Z
	goto _w_write
	movlw H'26'
	subwf par10,w
	btfsc STATUS,Z
	goto _w_read
	movlw H'F1'  		;bels fv-ek tesztelsei
	subwf par10,w
	btfsc STATUS,Z
	goto _parity
	movlw H'F2'
	subwf par10,w
	btfsc STATUS,Z
	goto _sorvissza
	movlw H'F3'
	subwf par10,w
	btfsc STATUS,Z
	goto _hanggen
	call resetport
	return

;fggvnyhvsos parancsok vgrehajtsai:
_sound:	clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call sound
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_nosound:clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call nosound
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_pwm:	clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call pwm
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_pwmoff:clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call pwm
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_lcd:	clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call lcd
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_bill:	clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call bill
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_kbhit:	clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call kbhit
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_lcdolv:clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call lcdolv
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_lcdstr:clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call lcdstr
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_flashr:clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call flashr
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_eewrite:;COMMAND 13H: paramter1=address, paramter2=data
	call receive
	movwf par2
	call receive
	movwf par3
	movf par2,w
	movwf par1
	movf par3,w
	call eewrite
	call resetport
	return

_eeread:;COMMAND 14H: paramter1=address, OUT=data
	call receive
	call eeread
	call send
	call resetport
	return

_fstring:clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call fstring
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_error:	clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call errorm
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_adcon:	clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call adcon
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_bip:	clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call bip
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_flashw:clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call flashw
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_clrlcd:clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call clrlcd
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_parity:clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call parity
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_sorvissza:clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call sorvissza
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_hanggen:clrf STATUS		;eltrolt W elhozsa
	movf wtar,w
	call hanggen
	clrf STATUS		;W eltrolsa (visszatrsi rtk)
	movwf wtar
	call resetport
	return

_w_write:	;parameter1=SEC
		;parameter2=CYLL
		;parameter3=CYLH
		;parameter4=HD		+512byte data
	call receive
	movwf par3
	call receive
	movwf par4
	call receive
	movwf par5
	call receive
	movwf par6
	call w_wrcom
	call d5nop
	call d5nop
	call d5nop
	clrf par7
w5:	call receive
	clrf STATUS
	movwf wdatal
	call receive
	clrf STATUS
	movwf wdatah
	movf wdatal,w
	clrf par1
	call wregw
	decfsz par7,f
	goto w5
	call resetport
	bsf PCLATH,3
	call wdelay
	clrf PCLATH
	return

_w_read:	;parameter1=SEC
		;parameter2=CYLL
		;parameter3=CYLH
		;parameter4=HD		OUT: byte data
	call receive
	movwf par3
	call receive
	movwf par4
	call receive
	movwf par5
	call receive
	movwf par6
	call w_rcom
	bsf PCLATH,3
	call wdelay
	call wdelay
	call wdelay
	clrf PCLATH
	clrf par7
w6:	clrf par1
	call wregr
	clrf STATUS
	call send
	clrf STATUS
	movf wdatah,w
	call send
	decfsz par7,f
	goto w6
	call resetport
	return

pvege:	movf par11,w		;Parancsport rutin vge
	movwf par1		;paramterek visszalltsa
	movf par12,w
	movwf par2
	call resetport
	return

portwrite:			;receive data and write the PIC port
	call receive		;Which port?
	movwf par10
	call receive		;data to write
	movwf par9
	movlw H'00'
	subwf par10,w
	btfsc STATUS,Z
	goto pwporta
	movlw H'01'
	subwf par10,w
	btfsc STATUS,Z
	goto pwportb
	movlw H'02'
	subwf par10,w
	btfsc STATUS,Z
	goto pwportc
	movlw H'03'
	subwf par10,w
	btfsc STATUS,Z
	goto pwportd
pwporte:clrf STATUS
	bsf STATUS,RP0
	movlw 00h
	movwf TRISE
	clrf STATUS
	movf par9,w
	movwf PORTE
	goto pvege
pwporta:clrf STATUS
	bsf STATUS,RP0
	movlw 00h
	movwf TRISA
	clrf STATUS
	movf par9,w
	movwf PORTA
	goto pvege
pwportb:clrf STATUS
	bsf STATUS,RP0
	movlw 00h
	movwf TRISB
	clrf STATUS
	movf par9,w
	movwf PORTB
	goto pvege
pwportc:clrf STATUS
	bsf STATUS,RP0
	movlw 00h
	movwf TRISC
	clrf STATUS
	movf par9,w
	movwf PORTC
	bsf STATUS,RP0
	bsf TRISC,7
	goto pvege
pwportd:clrf STATUS
	bsf STATUS,RP0
	movlw 00h
	movwf TRISD
	clrf STATUS
	movf par9,w
	movwf PORTD
	goto pvege

portread:                       ;read the PIC port and send data
	call receive		;Which port?
	movwf par10
	movlw H'00'
	subwf par10,w
	btfsc STATUS,Z
	goto prporta
	movlw H'01'
	subwf par10,w
	btfsc STATUS,Z
	goto prportb
	movlw H'02'
	subwf par10,w
	btfsc STATUS,Z
	goto prportc
	movlw H'03'
	subwf par10,w
	btfsc STATUS,Z
	goto prportd
prporte:clrf STATUS
	bsf STATUS,RP0
	movlw 0FFh
	movwf TRISE
	clrf STATUS
	movf PORTE,w
	call send
	bsf STATUS,RP0
	clrf TRISE
	goto pvege
prporta:clrf STATUS
	bsf STATUS,RP0
	movlw 0FFh
	movwf TRISA
	clrf STATUS
	movf PORTA,w
	call send
	goto pvege
prportb:clrf STATUS
	bsf STATUS,RP0
	movlw 0FFh
	movwf TRISB
	clrf STATUS
	movf PORTB,w
	call send
	goto pvege
prportc:clrf STATUS
	bsf STATUS,RP0
	movlw 0FFh
	movwf TRISC
	clrf STATUS
	movf PORTC,w
	call send
	bsf STATUS,RP0
	bcf TRISC,6
	bcf TRISC,0
	goto pvege
prportd:clrf STATUS
	bsf STATUS,RP0
	movlw 0FFh
	movwf TRISD
	clrf STATUS
	movf PORTD,w
	call send
	goto pvege

stop:clrf STATUS		;kpernyfrissts lelltsa
	bsf sstate,3		;set stop state
	goto pvege

continue:clrf STATUS	;stop state vge
	clrf sstate
	goto pvege

writemem:			;RAM file register write
	call receive
	movwf par10		;cm rsze: BANK no.
	call receive
	movwf par9		;cm low 7 bit
	call receive
	movwf par8		;data
	movf par9,w
	movwf FSR
	bcf FSR,7
	btfsc par10,0
	bsf FSR,7
	bcf STATUS,IRP
	btfsc par10,1
	bsf STATUS,IRP
	movf par8,w
	movwf INDF
	goto pvege

readmem:			;RAM file register read
	call receive
	movwf par10		;cm rsze: BANK no.
	call receive
	movwf par9		;cm low 7 bit
	movf par9,w
	movwf FSR
	bcf FSR,7
	btfsc par10,0
	bsf FSR,7
	bcf STATUS,IRP
	btfsc par10,1
	bsf STATUS,IRP
	movf INDF,w
	call send
	goto pvege

reset:	goto H'0000'		;System reset

wwrite:	call receive		;W ideiglenes trhely belltsa (param tads)
	clrf STATUS
	movwf wtar
	goto pvege

wread:	clrf STATUS		;W trhely olvassa (fv rtk kiolv.)
	movf wtar,w
	call send
	goto pvege


;PROGRAM MEMORY PAGE BOUNDARY
;	PAGE2
	ORG 800H

;I8085 INTERFACE functions
read85:				;read from CPU I8085
	clrf STATUS		;w=data
wait85_1:
	bcf INTCON,GIE		;wait for request
	bsf STATUS,RP0
	movlw 0FFh
	movwf TRISD
	clrf STATUS
	bsf PORTA,4
	clrf PCLATH
	call d5nop
	bsf PCLATH,3
	movf PORTD,w
	movwf state85
	bcf PORTA,4
	bsf STATUS,RP0
	clrf TRISD
	clrf STATUS
	bsf INTCON,GIE
	clrf PCLATH
	call d5nop
	call d5nop
	bsf PCLATH,3
	btfsc state85,3
	goto wait85_1
	btfss state85,2		;valban rsi krelem?
	goto syserror
	bsf INTCON,GIE
	movlw 0C5h		;kiolvass
	movwf PORTD
	bcf PORTD,7
	bsf PORTA,2
	bcf PORTA,2
	bsf STATUS,RP0
	movlw 0FFh
	movwf TRISD
	clrf STATUS
	bcf PORTA,3
	clrf PCLATH
	call d5nop
	bsf PCLATH,3
	movf PORTD,w
	movwf s85
	bsf PORTA,3
	bsf STATUS,RP0
	clrf TRISD
	clrf STATUS
	movlw 0C5h
	movwf PORTD
	bsf PORTA,2
	bcf PORTA,2
	bsf INTCON,GIE
	nop
	bcf INTCON,GIE		;ready jel adsa
	movlw 27h
	movwf PORTB
	bcf PORTB,0
	bsf PORTC,3		;felfuts, READY=1
	bcf PORTC,3		;1us delay (1 8085cycle)
	nop
	nop
	nop
	nop
	nop
	bsf PORTB,0
	bsf PORTC,3		;READY FF lefuts
	bcf PORTC,3		;A kvetkez I8085 ut. nem lehet IN/OUT
	bsf INTCON,GIE
	movf s85,w
	return

write85:	;write to CPU I8085
	clrf STATUS
	movwf s85		;w=data
wait85_2:			;vrs krelemre
	bcf INTCON,GIE		;wait for request
	bsf STATUS,RP0
	movlw 0FFh
	movwf TRISD
	clrf STATUS
	bsf PORTA,4
	clrf PCLATH
	call d5nop
	bsf PCLATH,3
	movf PORTD,w
	movwf state85
	bcf PORTA,4
	bsf STATUS,RP0
	clrf TRISD
	clrf STATUS
	bsf INTCON,GIE
	clrf PCLATH
	call d5nop
	call d5nop
	bsf PCLATH,3
	btfsc state85,3
	goto wait85_2
	btfss state85,1		;valban olvassi krelem?
	goto syserror
	bcf INTCON,GIE
	movlw 67h		;set to HOLD
	movwf PORTB
	bsf PORTC,3
	bcf PORTC,3
	movlw 0C5h
	movwf PORTD
	bsf PORTA,2
	bcf PORTA,2
	movf s85,w		;data OUT
	movwf PORTD
	bcf PORTA,3
	nop
	nop
	bcf PORTB,0		;READY=1
	bsf PORTC,3
	bcf PORTC,3
	nop				;1us
	nop
	nop
	nop
	nop
	bsf PORTB,0
	bsf PORTC,3
	bcf PORTC,3
	nop
	nop
	bsf PORTA,3		;bus zrsa
	bsf PORTA,4		;HOLD ellenrzse
	bsf STATUS,RP0
	movlw 0FFh
	movwf TRISD
	clrf STATUS
	movf PORTD,w
	bsf STATUS,RP0
	clrf TRISD
	clrf STATUS
	bsf INTCON,GIE
	movwf s85
	btfss s85,0
	goto syserror
	bcf INTCON,GIE		;HOLD=0
	clrf STATUS		;start CPU
	movlw 27h
	movwf PORTB
	bsf PORTC,3
	bcf PORTC,3
	bcf PORTB,0		;set READY=1
	bsf PORTC,3
	bcf PORTC,3
	bsf PORTB,0
	bsf PORTC,3
	bcf PORTC,3
	bcf INTCON,GIE
	return

syserror:movlw 1		;ERROR1=I8085 IF error
	clrf PCLATH
	call errorm
	bsf PCLATH,3
errck:  nop
	nop
	nop
	nop
	nop
	goto errck

read85ram:				;RAM visszaolvassa, boot tesztelse
	bcf INTCON,GIE		;IN:par1=memcm, OUT:par1:data
	clrf STATUS
	movlw 37h
	movwf PORTD
	movwf PORTB
	bsf PORTC,3
	bcf PORTC,3
	movlw 0C5h			;cmkiads
	movwf PORTD
	bsf PORTA,2
	bcf PORTA,2
	bcf PORTA,3
	movf par1,w
	movwf PORTD
	movlw 37h			;cmstrobe
	movwf PORTB
	bsf PORTB,3
	bsf PORTC,3
	bcf PORTC,3
	bcf PORTB,3
	bsf PORTC,3
	bcf PORTC,3
	movlw 37h			;read
	movwf PORTB
	bcf PORTB,1
	bsf PORTC,3
	bcf PORTC,3
	movlw 0C5h
	movwf PORTD
	bcf PORTD,7
	bsf PORTA,2
	bcf PORTA,2
	bsf STATUS,RP0		;read in
	movlw 0FFh
	movwf TRISD
	clrf STATUS
	movf PORTD,w
	movwf par1
	bsf STATUS,RP0		;restore
	clrf TRISD
	clrf STATUS
	bsf PORTA,3
	movlw 37h
	movwf PORTD
	movwf PORTB
	bsf PORTC,3
	bcf PORTC,3
	return

wdelay:					;delay for winchester ~100us
	clrf STATUS
	movlw d'100'
	movwf wkes
wdck: nop
	nop
	nop
	nop
	nop
	decfsz wkes,f
	goto wdck
	return

;SYSTEM STARTUP
;DEVICE BOOTING FROM EEPROM AND WINCHESTER
start:
;goto test ;TEST!
goto atugrx	;teszt rutinok tugrsa

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!test area
test:
clrf PCLATH
;call winit
call wregr
call wregw
bsf PCLATH,3
goto test

clrf PCLATH
call winit
bsf PCLATH,3
movlw 07h
movwf par1
clrf STATUS
clrf wdatah
movlw 0e0h
clrf PCLATH
call wregw
bsf PCLATH,3
idee: goto idee

;call write85
;wirex: goto wirex
clrf PCLATH
movlw 00h
movwf par1
movlw 3Eh
call eewrite
movlw 01h
movwf par1
movlw 0C0h
call eewrite
movlw 02h
movwf par1
movlw 30h
call eewrite
movlw 03h
movwf par1
movlw 3Eh
call eewrite
movlw 04h
movwf par1
movlw 14h
call eewrite
movlw 05h
movwf par1
movlw 0D3h
call eewrite
movlw 06h
movwf par1
movlw 12h
call eewrite
movlw 07h
movwf par1
movlw 3Eh
call eewrite
movlw 08h
movwf par1
movlw 40h
call eewrite
movlw 09h
movwf par1
movlw 30h
call eewrite
movlw 0Ah
movwf par1
movlw 3Eh
call eewrite
movlw 0Bh
movwf par1
movlw 00h
call eewrite
movlw 0Ch
movwf par1
movlw 0D3h
call eewrite
movlw 0Dh
movwf par1
movlw 34h
call eewrite
movlw 0Eh
movwf par1
movlw 0DBh
call eewrite
movlw 0Fh
movwf par1
movlw 55h
call eewrite
movlw 10h
movwf par1
movlw 47h
call eewrite
movlw 11h
movwf par1
movlw 3Eh
call eewrite
movlw 12h
movwf par1
movlw 16h
call eewrite
movlw 13h
movwf par1
movlw 0D3h
call eewrite
movlw 14h
movwf par1
movlw 12h
call eewrite
movlw 15h
movwf par1
movlw 78h
call eewrite
movlw 16h
movwf par1
movlw 0D3h
call eewrite
movlw 17h
movwf par1
movlw 55h
call eewrite
movlw 18h
movwf par1
movlw 0C3h
call eewrite
movlw 19h
movwf par1
movlw 00h
call eewrite
movlw 1Ah
movwf par1
movlw 00h
call eewrite
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!test area ends

atugrx:
;START: Winchester reset
	clrf PCLATH
	call winit
	bsf PCLATH,3
;BOOT
	bcf INTCON,GIE
	clrf STATUS		;CPU -reset=0
	movlw 17h
	movwf PORTB
	bcf PORTC,3
	bsf PORTC,3
	bcf PORTC,3
	clrf PCLATH		;delay 3us
	call d5nop
	call d5nop
	call d5nop
	bsf PORTB,5		;CPU -reset=1;
	bsf PORTC,3
	bcf PORTC,3
	call d5nop
	call d5nop
	call d5nop
	bsf PCLATH,3
	bcf PORTA,3		;open bus
	clrf par1		;Boot device code
bootcikl:			;256X
	movf par1,w
	movwf PORTD
	clrf PCLATH
	call eeread
	bsf PCLATH,3
	bsf PORTB,3		;cm strobe
	bsf PORTC,3
	bcf PORTC,3
	bcf PORTB,3
	bsf PORTC,3
	bcf PORTC,3
	movwf PORTD		;data OUT
	bcf PORTB,2		;data strobe
	bsf PORTC,3
	bcf PORTC,3
	bsf PORTB,2
	bsf PORTC,3
	bcf PORTC,3
	incfsz par1,f
	goto bootcikl

;!!!!!!!!!!!!!!!!! test
	;movlw 00h
	;movwf par1
	;call read85ram
;!!!!!!!!!!!!!!!!  test vge

	clrf STATUS		;CPU -reset=0 (second rst)
	movlw 17h
	movwf PORTB
	bsf PORTC,3
	bcf PORTC,3
	bsf PORTA,3		;enable CPU
	bcf PORTB,4
	bsf PORTC,3
	bcf PORTC,3
	clrf PCLATH		;delay 3us
	call d5nop
	call d5nop
	call d5nop
	bsf PCLATH,3
	bsf PORTB,5		;CPU -reset=1
	bsf PORTC,3
	bcf PORTC,3
	bcf PORTB,0		;reset Ready FF, start 8085CPU
	bsf PORTC,3
	bcf PORTC,3
	bsf PORTB,0
	bsf PORTC,3
	bcf PORTC,3
	bsf INTCON,GIE

;PIC-I8085 INTERFACE
cycle85:			;vgtelen ciklus
	clrf STATUS
	bcf INTCON,GIE
	bsf STATUS,RP0
	movlw 0FFH
	movwf TRISD
	clrf STATUS
	bsf PORTA,4
	clrf PCLATH
	call d5nop
	call d5nop
	movf PORTD,w
	movwf state85
	bcf PORTA,4
	bsf STATUS,RP0
	clrf TRISD
	clrf STATUS
	bsf INTCON,GIE
	call d5nop
	call d5nop
	bsf PCLATH,3
	btfsc state85,3
	goto cycle85
	call read85		;w=data
	movwf par1
;I8085 COMMAND INTERPRETER  jump table
	movlw 0Dh
	subwf par1,w
	btfsc STATUS,Z
	goto i_lcd
	movlw 11h
	subwf par1,w
	btfsc STATUS,Z
	goto i_lcdstr
	movlw 23h
	subwf par1,w
	btfsc STATUS,Z
	goto i_clrlcd
	movlw 0Eh
	subwf par1,w
	btfsc STATUS,Z
	goto i_bill
	movlw 0Fh
	subwf par1,w
	btfsc STATUS,Z
	goto i_kbhit
	movlw 50h
	subwf par1,w
	btfsc STATUS,Z
	goto i_resetport
	movlw 51h
	subwf par1,w
	btfsc STATUS,Z
	goto i_send
	movlw 52h
	subwf par1,w
	btfsc STATUS,Z
	goto i_receive
	movlw 16h
	subwf par1,w
	btfsc STATUS,Z
	goto i_errorm
	movlw 08h
	subwf par1,w
	btfsc STATUS,Z
	goto i_sound
	movlw 09h
	subwf par1,w
	btfsc STATUS,Z
	goto i_nosound
	movlw 20h
	subwf par1,w
	btfsc STATUS,Z
	goto i_bip
	movlw 17h
	subwf par1,w
	btfsc STATUS,Z
	goto i_adcon
	movlw 14h
	subwf par1,w
	btfsc STATUS,Z
	goto i_eeread
	movlw 13h
	subwf par1,w
	btfsc STATUS,Z
	goto i_eewrite
	movlw 12h
	subwf par1,w
	btfsc STATUS,Z
	goto i_flashr
	movlw 15h
	subwf par1,w
	btfsc STATUS,Z
	goto i_fstring
	movlw 53h
	subwf par1,w
	btfsc STATUS,Z
	goto i_clrscr
	movlw 54h
	subwf par1,w
	btfsc STATUS,Z
	goto i_putpixel
	movlw 55h
	subwf par1,w
	btfsc STATUS,Z
	goto i_shiftr
	movlw 56h
	subwf par1,w
	btfsc STATUS,Z
	goto i_shiftl
	movlw 57h
	subwf par1,w
	btfsc STATUS,Z
	goto i_shiftu
	movlw 58h
	subwf par1,w
	btfsc STATUS,Z
	goto i_shiftd
	movlw 59h
	subwf par1,w
	btfsc STATUS,Z
	goto i_winit
	movlw 25h
	subwf par1,w
	btfsc STATUS,Z
	goto i_writew
	movlw 26h
	subwf par1,w
	btfsc STATUS,Z
	goto i_readw
	movlw 27h
	subwf par1,w
	btfsc STATUS,Z
	goto i_wstop
	movlw 61h
	subwf par1,w
	btfsc STATUS,Z
	goto i_cputb
	movlw 62h
	subwf par1,w
	btfsc STATUS,Z
	goto i_cload
	goto cycle85

;jump table destinations
i_lcd:	call read85
	movwf par1
	call read85
	movwf par2
	call read85
	clrf PCLATH
	call lcd
	bsf PCLATH,3
	goto cycle85

i_lcdstr:call read85
	movwf par5
	btfsc par5,0
	goto sor1
next5:	btfsc par5,1
	goto sor2
	goto cycle85
sor1:	movlw d'16'
	movwf par3
	movlw 0A0h
	movwf FSR
s1ck:	call read85
	movwf INDF
	incf FSR,f
	decfsz par3,f
	goto s1ck
	movlw 01h
	clrf PCLATH
	call lcdstr
	bsf PCLATH,3
	goto next5
sor2:	movlw d'16'
	movwf par3
	movlw 0B0h
	movwf FSR
s2ck:	call read85
	movwf INDF
	incf FSR,f
	decfsz par3,f
	goto s2ck
	movlw 02h
	clrf PCLATH
	call lcdstr
	bsf PCLATH,3
	goto cycle85

i_clrlcd:clrf PCLATH
	call clrlcd
	bsf PCLATH,3
	goto cycle85

i_bill: clrf PCLATH
	call bill
	bsf PCLATH,3
	call write85
	goto cycle85

i_kbhit:clrf PCLATH
	call kbhit
	bsf PCLATH,3
	call write85
	goto cycle85

i_resetport:clrf PCLATH
	call resetport
	bsf PCLATH,3
	goto cycle85

i_send:	call read85
	clrf PCLATH
	call send
	bsf PCLATH,3
	goto cycle85

i_receive:clrf PCLATH
	call receive
	bsf PCLATH,3
	call write85
	goto cycle85

i_errorm:call read85
	clrf PCLATH
	call errorm
	bsf PCLATH,3
	goto cycle85

i_sound:call read85
	movwf par2
	call read85
	movwf par1
	movf par2,w
	clrf PCLATH
	call sound
	bsf PCLATH,3
	goto cycle85

i_nosound:clrf PCLATH
	call nosound
	bsf PCLATH,3
	goto cycle85

i_bip:  clrf PCLATH
	call bip
	bsf PCLATH,3
	goto cycle85

i_adcon:clrf PCLATH
	call adcon
	bsf PCLATH,3
	movf par1,w
	call write85
	movf par2,w
	call write85
	goto cycle85

i_eeread:call read85
	clrf PCLATH
	call eeread
	bsf PCLATH,3
	call write85
	goto cycle85

i_eewrite:call read85
	movwf par2
	call read85
	movwf par1
	movf par2,w
	clrf PCLATH
	call eewrite
	bsf PCLATH,3
	goto cycle85

i_flashr:call read85
	movwf par2
	call read85
	movwf par1
	clrf PCLATH
	call flashr
	bsf PCLATH,3
	movf par1,w
	movwf par3
	movf par2,w
	call write85
	movf par3,w
	call write85
	goto cycle85

i_fstring:call read85
	movwf par2
	call read85
	movwf par1
	movlw 20h
	movwf par3
	movlw 20h
	clrf PCLATH
	call fstring
	movlw 03h
	call lcdstr
	bsf PCLATH,3
	goto cycle85

i_clrscr:clrf PCLATH
	call clrscr
	bsf PCLATH,3
	goto cycle85

i_putpixel:
	call read85
	movwf par4
	call read85
	movwf par2
	call read85
	movwf par3
	movf par4,w
	movwf par1
	clrf PCLATH
	call putpixel
	bsf PCLATH,3
	goto cycle85

i_shiftr:call read85
	movwf par1
	clrf PCLATH
	call shiftr
	bsf PCLATH,3
	goto cycle85

i_shiftl:call read85
	movwf par1
	clrf PCLATH
	call shiftl
	bsf PCLATH,3
	goto cycle85

i_shiftu:clrf PCLATH
	call shiftu
	bsf PCLATH,3
	goto cycle85

i_shiftd:clrf PCLATH
	call shiftd
	bsf PCLATH,3
	goto cycle85

i_winit:clrf PCLATH
	call winit
	bsf PCLATH,3
	goto cycle85

i_writew:
	call read85
	movwf par3
	call read85
	movwf par4
	call read85
	movwf par5
	call read85
	movwf par6
	clrf PCLATH
	call w_wrcom
	call d5nop
	call d5nop
	call d5nop
	bsf PCLATH,3
	clrf par7
w51:	call read85
	clrf STATUS
	movwf wdatal
	call read85
	clrf STATUS
	movwf wdatah
	movf wdatal,w
	clrf par1
	clrf PCLATH
	call wregw
	bsf PCLATH,3
	decfsz par7,f
	goto w51
	call wdelay
	call wdelay
	call wdelay
	goto cycle85

i_readw:
	bcf INTCON,GIE
	call read85
	movwf par3
	call read85
	movwf par4
	call read85
	movwf par5
	call read85
	movwf par6
	clrf PCLATH
	call w_rcom
	bsf PCLATH,3
	call wdelay
	call wdelay
	call wdelay
	clrf par7
w62:	clrf par1
	clrf PCLATH
	call wregr
	bsf PCLATH,3
	clrf STATUS
	call write85
	clrf STATUS
	movf wdatah,w
	call write85
	decfsz par7,f
	goto w62
	bsf INTCON,GIE
	goto cycle85

i_wstop:
	movlw 07h
	movwf par1
	clrf STATUS
	clrf wdatah
	movlw 0e0h
	clrf PCLATH
	call wregw
	bsf PCLATH,3
	goto cycle85

i_cputb:			;void cputb(int addr,int data);
	call read85		;addr[0-79]
	movwf FSR
	call read85
	movwf par2
	clrf STATUS
	bsf STATUS,IRP
	movlw 90H
	addwf FSR,f
	movf par2,w
	movwf INDF
	goto cycle85

i_cload:			;void cload(it data[80]);
	movlw 90H
	movwf FSR
	movlw d'80'
	movwf par2
	clrf STATUS
clcikl:
	call read85
	clrf STATUS
	bsf STATUS,IRP
	movwf INDF
	incf FSR,f
	decfsz par2,f
	goto clcikl
	goto cycle85

Test:					;tesztpont jelzs RS232-n t 
	clrf STATUS			;w= to send
	clrf PCLATH			;w=testreg=received
	call send
	call receive
	call resetport
	clrf STATUS
	movwf testreg
	bsf PCLATH,3
	return

Testsend:				;tesztpont jelzs, w=tosend, nem vr
	clrf STATUS			;w= to send
	clrf PCLATH
	call send
	call resetport
	bsf PCLATH,3	
	return

;!!!!!!!!!!!!!!!!!!!!test - tesztvektor
testvec:
	clrf PCLATH
	call clrlcd
			;PORTB inicializci
	clrf STATUS		;billenyt kdot a ledekre
	bsf STATUS,RP0		;bank1
	clrf TRISB
	clrf STATUS		;bank0
	clrf PORTB
	
	movlw 84h		;write 'A'
	clrf PCLATH
	call wr_com
	call d10
	movlw 'A'		;'A'
	call wr_data
	call d10

	movlw 85h		;write 't'
	call wr_com
	call d10
	movlw 't'		;'t'
	call wr_data
	call d10

	movlw 86h		;write 'o'
	call wr_com
	call d10
	movlw 'o'		;'o'
	call wr_data
	call d10

	movlw 87h		;write 'm'
	call wr_com
	call d10
	movlw 'm'		;'m'
	call wr_data
	call d10

	movlw 81h		;X kirsa
	call wr_com
	call d10
	movlw 'X'
	call wr_data
	call d10
	bsf PCLATH,3

cikl:clrf PCLATH	
	call d10 
	call bill		;billentyciklus
	movwf PORTB		;Kd ledekre rsa(PORTB)
	andlw 0FFh
	bsf PCLATH,3
	btfsc STATUS,Z
	goto cikl

	clrf PCLATH
	addlw D'48'
	movwf par3
	call d10
	movlw 81h		;write the number
	call wr_com
	call d10
	movf par3,w
	call wr_data
	call d10
	bsf PCLATH,3
	goto cikl




start3:	clrf STATUS		;villog fny
	bsf STATUS,RP0		;bank1
	clrf TRISB
	clrf STATUS		;bank0
	clrf PORTB
	bsf PORTB,0
	bcf STATUS,C
cikl1:	rlf PORTB,f
	movlw 0ffh		;200 ms kss
	movwf par1
	movlw D'392'
	movwf par2
	call kes2
	movlw 0ffh		;200 ms kss
	movwf par1
	movlw D'392'
	movwf par2
	call kes2
	goto cikl1



start33:clrf STATUS		;billenyt kdot a ledekre
	bsf STATUS,RP0		;bank1
	clrf TRISB
	clrf STATUS		;bank0
	clrf PORTB
cikl33:	call bill
	movwf PORTB
	goto cikl33

;!!!!!!!!!!!!!!!!!!!test vge



;TEXT CONSTANTS TO WRITE
	ORG 1E40h
	dw "0O0h0 0N0O0O0O0!0 0 0 0 0 0 0 0 0Y0o0u0 0L0O0S0T0!0 0 0 0 0 0 0 "
	ORG 1E60h
	dw "0C0o0n0g0r0a0t0u0l0a0t0i0o0n0s0 0Y0O0U0 0w0i0n0 0t0h0e0 0G0A0M0E"
	ORG 1E80h
	dw "0G0A0M0E0 0M0o0o0n0 0B0a0s0e0 0 0S0u0p0e0r0 0s0h0o0o0t0e0r0 0 0 "
	ORG 1EA0h
	dw "0R0u0n0n0i0n0g0 0Q0u0e0n0n0e0 0 0B0A0N0D0S0 0S0P0E0C0T0R0U0M0 0 "
	ORG 1EC0h
	dw "0S0t0a0r0t0i0n0g0 0 0 0 0 0 0 0 0B0A0N0D0S0 0S0P0E0C0T0R0U0M0 0 "
	ORG 1EE0h
	dw "0E0R0R0O0R0 0 0 0 0 0 0 0 0 0 0 0B0A0N0D0S0 0-0>0 0Q0u0e0n0n0e0 "
	END
