list	p=16f877A                 ; Processzor  PIC16F877A
#include <P16f877A.inc>           ; processor header file

	__CONFIG 3F32h
	__IDLOCS 5555h          ; ID (azonosito)

	ORG 0
	clrf STATUS		;bank0
	clrf PORTE
	bsf STATUS,RP0		;bank1
	movlw 0C7h
	movf OPTION_REG,f
	clrf INTCON		;disable ITs
	clrf PIE1
	clrf PIE2
	movlw 07h
	movf ADCON1,f
	clrf TRISC		;set PORT C
	clrf TRISE		;set PORT E
	clrf CVRCON		;Compare module off
	movlw 07h
	movwf CMCON		;Compare default
	movlw 07h		;A/D off
	movwf ADCON1
	clrf STATUS		;bank0
	clrf T1CON		;timer1 off
	clrf T2CON		;timer2 off
	clrf CCP1CON		;CCP off
	clrf CCP2CON
	clrf SSPCON1		;SSP off
	clrf RCSTA		;USART off
	clrf ADCON0		;AD off
	clrf PIR1
	clrf PIR2
;LCD INICIALIZCI:
	clrf STATUS		;bank0
	clrf PORTC		;LCD tri state er on
	bsf STATUS,RP0
	clrf TRISC
	movlw D'100'		;delay 20ms
	movwf par1
	movlw D'100'
	movwf par2
	call kes2
	movlw 38h		;function set
	call wr_com
	movlw D'250'		;delay 5ms
	movwf par1
	movlw D'10'
	movwf par2
	call kes2
	movlw 38h		;function set
	call wr_com
	movlw D'75'		;delay 150us
	movwf par1
	call kes1
	movlw 38h		;function set
	call wr_com
	movlw 38h		;function set
	call wr_com
	movlw 08h		;display off
	call wr_com
	movlw 01h		;clear display
	call wr_com
	call d2ms		;2ms delay
	movlw 06h		;entry mode set
	call wr_com
	movlw 0Fh		;display on
	call wr_com
	movlw 02h		;return home
	call wr_com
	call d2ms		;2ms delay
	
	goto start		;goto main program

;minden bank-rl elrhet regiszterek paramterek:
	par1 EQU 7Fh
	par2 EQU 7Eh
	par3 EQU 7Dh
	par4 EQU 7Ch
	par5 EQU 7Bh
	par6 EQU 7Ah
	par7 EQU 79h
	par8 EQU 78h
	par9 EQU 77h
	par10 EQU 76h
	par11 EQU 75h
	par12 EQU 74h
	par13 EQU 73h
	par14 EQU 72h
	par15 EQU 71h
	par16 EQU 70h

;DELAYING
kes1:	nop		;IN: par1=ksleltets[us]/2
	nop		;2us-512us
	nop
	nop
	nop
	nop
	nop
	decfsz par1,f
	goto kes1
	return

kes2:	nop		;IN: ksleltets[us]=par1*2*par2+par2*0.2
	nop		2us-131ms
	nop
	nop
	nop
	nop
	nop
	decfsz par1,f
	goto kes2
	decfsz par2,f
	goto kes2
	return

d10:			;10 us delay
	movlw 05h
	movwf par1
	call kes1
	return

d2ms:			;2ms delay
	movlw D'100'	;clear display+return home utn kell
	movwf par1
	movlw D'10'
	movlw par2
	call kes2
	return
	
;WRITING & READING THE LCD
wr_com:				;command write
	clrf STATUS		;w=command
	bsf STATUS,RP0		;bank1
	clrf TRISD
	clrf STATUS		;bank0
	movwf PORTD		;data out
	clrf PORTE
	call d10		;10 us delay
	movlw 02h
	movwf PORTE
	call d10		;10 us delay
	clrf PORTE
	movlw D'25'		;50 us delay
	movwf par1
	call kes1
	return

wr_data:			;write data
	clrf STATUS		;w=data
	bsf STATUS,RP0		;bank1
	clrf TRISD
	clrf STATUS		;bank0
	movwf PORTD		;data out
	movlw 04h
	movwf PORTE
	call d10		;10us delay
	movlw 06h
	movwf PORTE
	call d10		;10us delay
	movlw 04h
	movwf PORTE
	movlw D'25'		;50us delay
	movwf par1
	call kes1
	return

rd_data:			;read data
	clrf STATUS		;w=data
	bsf STATUS,RP0		;bank1
	clrf TRISD
	comf TRISD,f
	clrf STATUS		;bank0
	movlw 05h
	movwf PORTE
	call d10		;10us delay
	movlw 07h
	movwf PORTE
	movlw D'25'		;50us delay
	movwf par1
	call kes1
	movf PORTD,w		;kiolvas
	movlw 05h
	movwf PORTE
	call d10		;10us delay
	return

;BILLENTYKEZELS:
bill:	call bill1		;Azrt kell hogy vissza is lltsa az LCD-t a rutin
	clrf PORTC		;LCD visszalltsa, billentycsatorna zrsa
	return
bill1:				;w=scan code
	clrf STATUS		;w=0 ha nincs lenyomva semmi
	bsf STATUS,RP0		;bank1
	movlw 0AAh
	movwf TRISD
	clrf STATUS		;bank0
	movlw 01h
	movwf PORTC		;ideiglenes vlts PORTC-t megvltoztatja!!!!
	call d10
	movlw 0FEh		;oszlopvlts
	movwf PORTD
	call d10
	btfss PORTD,7
	retlw 1
	btfss PORTD,5
	retlw 2
	btfss PORTD,3
	retlw 3
	btfss PORTD,1
	retlw 4
	movlw 0FBh		;oszlopvlts
	movwf PORTD
	call d10
	btfss PORTD,7
	retlw 5
	btfss PORTD,5
	retlw 6
	btfss PORTD,3
	retlw 7
	btfss PORTD,1
	retlw 8
	movlw 0EFh		;oszlopvlts
	movwf PORTD
	call d10
	btfss PORTD,7
	retlw 9
	btfss PORTD,5
	retlw D'10'
	btfss PORTD,3
	retlw D'11'
	btfss PORTD,1
	retlw D'12'
	movlw 0BFh		;oszlopvlts
	movwf PORTD
	call d10
	btfss PORTD,7
	retlw D'13'
	btfss PORTD,5
	retlw D'14'
	btfss PORTD,3
	retlw D'15'
	btfss PORTD,1
	retlw D'16'
	retlw 0

;MAIN PROGRAM:	
start:				;PORTB inicializci
	clrf STATUS		;billenyt kdot a ledekre
	bsf STATUS,RP0		;bank1
	clrf TRISB
	clrf STATUS		;bank0
	clrf PORTB
	
	movlw 84h		;write 'A'
	call wr_com
	call d10
	movlw 'A'		;'A'
	call wr_data
	call d10

	movlw 85h		;write 't'
	call wr_com
	call d10
	movlw 't'		;'t'
	call wr_data
	call d10

	movlw 86h		;write 'o'
	call wr_com
	call d10
	movlw 'o'		;'o'
	call wr_data
	call d10

	movlw 87h		;write 'm'
	call wr_com
	call d10
	movlw 'm'		;'m'
	call wr_data
	call d10

	movlw 81h		;X kirsa
	call wr_com
	call d10
	movlw 'X'
	call wr_data
	call d10

cikl:	call d10 
	call bill		;billentyciklus
	movwf PORTB		;Kd ledekre rsa(PORTB)
	andlw 0FFh
	btfsc STATUS,Z
	goto cikl

	addlw D'48'
	movwf par3
	call d10
	movlw 81h		;write the number
	call wr_com
	call d10
	movf par3,w
	call wr_data
	call d10
	goto cikl




start3:	clrf STATUS		;villog fny
	bsf STATUS,RP0		;bank1
	clrf TRISB
	clrf STATUS		;bank0
	clrf PORTB
	bsf PORTB,0
	bcf STATUS,C
cikl1:	rlf PORTB,f
	movlw 0ffh		;200 ms kss
	movwf par1
	movlw D'392'
	movwf par2
	call kes2
	movlw 0ffh		;200 ms kss
	movwf par1
	movlw D'392'
	movwf par2
	call kes2
	goto cikl1



start33:clrf STATUS		;billenyt kdot a ledekre
	bsf STATUS,RP0		;bank1
	clrf TRISB
	clrf STATUS		;bank0
	clrf PORTB
cikl33:	call bill
	movwf PORTB
	goto cikl33


	END



