//***************************************************************************
//		PIC-I8085 project (c) Andras Bognar 07.2007
//					Program loader
//			The Quenne Electric company
//***************************************************************************

#include <windows.h>
#include "resource.h" 
#include <stdlib.h>
#include <stdio.h> 
#define	BMAX 10000		//soros FIFO buffer nagysga
#define EEwrite 1		//Vgrehajts alatt lv mvelet
#define EEread 2
#define Wwrite 3
#define Wread 4
#define CONNECT 5
#define StoreAll 6
#define RecSerial 7
#define x8split 8

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM) ;

//FILE
static char lpstrTeljesAllNev[_MAX_PATH];
static char lpstrAllNev[_MAX_FNAME+_MAX_EXT];
static OPENFILENAME ofn;
FILE *fp;
FILE *split;
int fbpoi;			//file byte pointer
int fbuffer[65536];	//file buffer (2048)
//GUI
char display[25][80];			//karakterkperny buffer
char input[100];				//input buffer
int bp=0;						//input buffer pointer
int bevitel=0;					//beviteli llapot flag
int cx,cy;						//cursor pos.
char cw='A';					//variable char;
HWND hwnd ;						//window1
HINSTANCE hinst;
RECT rect;
int x=0,y=0,ts=0;
// variables used with the com port
BOOL     m_bPortReady;
HANDLE   m_hCom;
DCB      m_dcb;
COMMTIMEOUTS m_CommTimeouts;
BOOL     bWriteRC;
BOOL     bReadRC;
DWORD	 iBytesWritten;
DWORD	 iBytesRead;
char     sBuffer[128];
int		 periodic=0; //periodic sending mode -test (send 0x55)
//serilal port state 
int BAUD=19200;
char rec[1024];	//vett adatok buffere
int rpoi=0;		//vett adatok szma eddig (rec pointere)
int vart=0;		//vrt adatok menyisge
int muvelet=0;	//vgrehajts alatt lv mvelet kdja
int connected=0;//csatlakoztatva az eszkz
int connecttime=0;//csatlakozsi id
int rectime=0;	//2 vtel kzt eltelt id
int RECTIMEMAX=30;
int dataproc=0;	//valamelyik adatfeldolgoz fggvny fut
//FIFO
char buffer[BMAX];
char* eleje=buffer;
char* vege=buffer;
int full=0;
//Winchester parameters
int sec=1,cyll=0,cylh=0,hd=0;
//Serial recording
char SRbuf[5000];
int SRpoi=0;	//buffer pointer
int SR=0;		//serial recording flag

//**************************** GUI routines *************************************

void putcharx(char charx){
	int fx,fy;
	if(charx==13)return;
	if(charx!=10)display[cy][cx]=charx;//10=sorvlts, 13-ignored
	else display[cy][cx]=' ';
	cx++;if((cx>79)||(charx==10)){cx=0;cy++;}
	if(cy>24){
		cy=24;
		for(fy=1;fy<25;fy++)for(fx=0;fx<80;fx++){
			display[fy-1][fx]=display[fy][fx];
		}
		for(fx=0;fx<80;fx++)display[24][fx]=' ';
	}
	display[cy][cx]='*';
}

void print(char charx){			//character
	putcharx(charx);
	GetClientRect (hwnd, &rect);
	InvalidateRect(hwnd,&rect,FALSE);
}

void print(char*str){			//string kiratsa
	int pos=0;
	while(str[pos])putcharx(str[pos++]);
	GetClientRect (hwnd, &rect);
	InvalidateRect(hwnd,&rect,FALSE);
	return ;
}

void print(int intx){		//decimal signed int
	char str[100];
	sprintf(str,"%d",intx);
	print(str);
}

void print(float floatx){	//float
	char str[100];
	sprintf(str,"%f",floatx);
	print(str);
}

void print(unsigned int intx){		//hexadecimal unsigned int
	char str[100];
	sprintf(str,"%X",intx);
	print(str);
}

//****************************** FIFO ******************************************
//Soros ad buffere
void push(char x){
	if(!full){
		*vege=x; vege++;
		if(vege>&buffer[BMAX-1]) vege=&buffer[0];
		if(vege==eleje) full=1;
	}
}

char pop(){
	char x;
	if(full||(eleje!=vege)){
		x=*eleje; *eleje=0; eleje++;
		if(eleje>&buffer[BMAX-1]) eleje=&buffer[0];
	}
	full=0;
	return x;
}

int empty(){
	if(!full&&(eleje==vege))return 1;
	else return 0;
}

//*********************************** SERIAL PORT********************************

void SerialInit(){
	m_hCom = CreateFile("Com1", 
		GENERIC_READ | GENERIC_WRITE,
		0, // exclusive access
		NULL, // no security
		OPEN_EXISTING,
		0, // no overlapped I/O
		NULL); // null template 
	m_bPortReady = SetupComm(m_hCom, 128, 128); // set buffer sizes
	m_bPortReady = GetCommState(m_hCom, &m_dcb);
	m_dcb.BaudRate = BAUD;
	m_dcb.ByteSize = 8;
	m_dcb.Parity = EVENPARITY;
	m_dcb.StopBits = ONESTOPBIT;
	m_dcb.fAbortOnError = TRUE;
	m_bPortReady = SetCommState(m_hCom, &m_dcb);
	m_bPortReady = GetCommTimeouts (m_hCom, &m_CommTimeouts);
	m_CommTimeouts.ReadIntervalTimeout = 50;
	m_CommTimeouts.ReadTotalTimeoutConstant = 50;
	m_CommTimeouts.ReadTotalTimeoutMultiplier = 10;
	m_CommTimeouts.WriteTotalTimeoutConstant = 50;
	m_CommTimeouts.WriteTotalTimeoutMultiplier = 10;
	m_bPortReady = SetCommTimeouts (m_hCom, &m_CommTimeouts);
}

//********************************** FILE KEZELS *******************************

//Filenv inicializci
void finit(HWND hwnd,OPENFILENAME *ofn){
	static char szFilter[]="Binris llomnyok (*.BIN)\0*.bin\0"\
		"Minden llomny (*.*)\0*.*\0\0";
	ofn->lStructSize		=sizeof(OPENFILENAME);
	ofn->hwndOwner		=hwnd;
	ofn->hInstance		=NULL;
	ofn->lpstrFilter	=szFilter;
	ofn->lpstrCustomFilter=NULL;
	ofn->nMaxCustFilter	=0;
	ofn->nFilterIndex	=0;
	ofn->lpstrFile		=NULL;
	ofn->nMaxFile		=_MAX_PATH;
	ofn->lpstrFileTitle	=NULL;
	ofn->nMaxFileTitle	=_MAX_FNAME+_MAX_EXT;
	ofn->lpstrInitialDir	=NULL;
	ofn->lpstrTitle		=NULL;
	ofn->Flags			=0;
	ofn->nFileOffset		=0;
	ofn->nFileExtension	=0;
	ofn->lpstrDefExt		="bin";
	ofn->lCustData		=0L;
	ofn->lpfnHook		=NULL;
	ofn->lpTemplateName	=NULL;
}

//Megnyits prbeszd ablak
BOOL Megnyit(HWND hwnd,LPSTR lpstrTeljesAllNev,LPSTR lpstrAllNev,OPENFILENAME *ofn){
	ofn->hwndOwner		=hwnd;
	ofn->lpstrFile		=lpstrTeljesAllNev;
	ofn->lpstrFileTitle	=lpstrAllNev;
	ofn->Flags			=OFN_HIDEREADONLY|OFN_CREATEPROMPT;
	return GetOpenFileName(ofn);
}

//Ments prbeszd ablak
BOOL Mentes(HWND hwnd,LPSTR lpstrTeljesAllNev,LPSTR lpstrAllNev,OPENFILENAME *ofn){
	ofn->hwndOwner		=hwnd;
	ofn->lpstrFile		=lpstrTeljesAllNev;
	ofn->lpstrFileTitle	=lpstrAllNev;
	ofn->Flags			=OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY;
	return GetSaveFileName(ofn);
}

//convert 4bit to hexadecimal
void convert(int x){
	sprintf(input,"%X",x);
	if(!input[1]){
		input[1]=input[0];input[0]=48;
	}
}

//***************************** RECEIVED DATA PROCESSOR ROUTINES ********************

void EEwrite_proc(){
	int x,w,error=0;
	for(x=0;x<256;x++){
		w=rec[x]&0xFF;if(w!=0x13)error=1;
	}
	if(error){
		print("\nCONNECTION ERROR - EEPROM writing\n\n");
		MessageBox(hwnd,"EEPROM writing Failed","Finished - ERROR",
								MB_ICONSTOP|MB_OK);
	}
	else{
		print("\nFINISHED - EEPROM writing\n\n");
		MessageBox(hwnd,"EEPROM writing finished","Finished",
								MB_ICONEXCLAMATION|MB_OK);
	}
}
void EEread_proc(){
	int x,xv,error=0,dpoi=0;
	char data[256];
	for(x=0;x<512;x++){
		if(x&01)data[dpoi++]=rec[x];
		else if(rec[x]!=0x14)error=1;
	}
	if(error){
		print("\nCONNECTION ERROR - EEPROM reading\n\n");
		MessageBox(hwnd,"EEPROM reading Failed","Finished - ERROR",
								MB_ICONSTOP|MB_OK);
	}
	else{
		print("\nFINISHED - EEPROM reading\n\n");
		MessageBox(hwnd,"EEPROM reading finished","Finished",
								MB_ICONEXCLAMATION|MB_OK);
	}

	if((fp=fopen(lpstrTeljesAllNev,"wb"))==NULL){//fileopen
		print("ERROR opening file\n");return;
	}
	for(xv=0;xv<256;xv++){//filewrite
		putc(data[xv],fp);
	}
	fclose(fp);//fileclose
}
void Wread_proc(){
	int xv;
	if((fp=fopen(lpstrTeljesAllNev,"wb"))==NULL){//fileopen
		print("ERROR opening file\n");return;
	}
	for(xv=1;xv<513;xv++){//filewrite
		putc(rec[xv],fp);
	}
	fclose(fp);//fileclose
	print("\nSUCCESS - Winchester reading finished\n");
			MessageBox(hwnd,"Winchester reading finished","Finished",
								MB_ICONEXCLAMATION|MB_OK);
}
void Wwrite_proc(){
	if(rec[0]==0x25){
		print("\nFINISHED - Winchester writing\n\n");
		MessageBox(hwnd,"Winchester writing finished","Finished",
								MB_ICONEXCLAMATION|MB_OK);
	}
	else{
		print("\nERROR - Winchester writing\n\n");
		MessageBox(hwnd,"Winchester writing failed","Failed",
								MB_ICONEXCLAMATION|MB_OK);
	}
}
void CONNECT_proc(){
	rpoi=0;muvelet=0;connected=1;print("\nSuccessfully connected\n");vart=0;
}

void StoreAll_proc(){
	print("\nFINISHED - Winchester storing\n\n");
	MessageBox(hwnd,"Winchester storing finished","Finished",MB_ICONEXCLAMATION|MB_OK);
	RECTIMEMAX=30;
}

void RecSerial_proc(){
	int fx;
	Mentes(hwnd,lpstrTeljesAllNev,lpstrAllNev,&ofn);
	if((fp=fopen(lpstrTeljesAllNev,"wb"))==NULL){//fileopen
		print("ERROR opening file\n");return;
	}
	for(fx=0;fx<SRpoi;fx++){
		putc(SRbuf[fx],fp);
	}
	fclose(fp);//fileclose
	SR=0;SRpoi=0;RECTIMEMAX=30;
	print("\nSerial recording stopped\n");
}

void x8split_proc(){
	print("\nFINISHED - Winchester special 8 sector storing\n\n");
	MessageBox(hwnd,"Winchester 8 sector storing finished","Finished",MB_ICONEXCLAMATION|MB_OK);
	RECTIMEMAX=30;
}

//********** Dialog box to input winchester parameters **************************


BOOL CALLBACK DialogProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam  ){
	BOOL siker,error=FALSE;
	switch(uMsg){
	case WM_INITDIALOG:
		return FALSE;
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case IDOK:
			sec=GetDlgItemInt(hwndDlg,IDC_EDIT1,&siker,FALSE);if(!siker)error=TRUE;
			cyll=GetDlgItemInt(hwndDlg,IDC_EDIT2,&siker,FALSE);if(!siker)error=TRUE;
			cylh=GetDlgItemInt(hwndDlg,IDC_EDIT3,&siker,FALSE);if(!siker)error=TRUE;
			hd=GetDlgItemInt(hwndDlg,IDC_EDIT4,&siker,FALSE);if(!siker)error=TRUE;
			if(error){
				MessageBox(hwnd,"Input error","ERROR",MB_ICONSTOP|MB_OK|MB_SYSTEMMODAL);
				return TRUE;
			}
			EndDialog(hwndDlg,0);
			print("SEC=");print(sec);print("  CYLL=");print(cyll);
			print("  CYLH=");print(cylh);print("  HD=");print(hd);print("\n");
			return TRUE;
		}
		break;
	}
	return FALSE;
}

//****************************** MAIN ***********************************************

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,PSTR szCmdLine, int iCmdShow){
     static char szAppName[] = "HelloWin" ;
     MSG         msg ;
     WNDCLASSEX  wndclass ;
	 HMENU	     hmenu1;

	 hinst=	hInstance;

     wndclass.cbSize        = sizeof (wndclass) ;
     wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
     wndclass.lpfnWndProc   = WndProc ;
     wndclass.cbClsExtra    = 0 ;
     wndclass.cbWndExtra    = 0 ;
     wndclass.hInstance     = hInstance ;
	 wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
     wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
     wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH) ;
     wndclass.lpszMenuName  = NULL ;
     wndclass.lpszClassName = szAppName ;
     wndclass.hIconSm       = LoadIcon (NULL,IDI_APPLICATION) ;
	 wndclass.lpszMenuName =  MAKEINTRESOURCE(IDR_MENU1); 

     RegisterClassEx (&wndclass) ;

     hwnd = CreateWindow (szAppName,         // window class name
		             "PIC-I8085 Loader program - (c) Bognar Andras 2007",      // window caption
                    WS_OVERLAPPEDWINDOW,     // window style
                    CW_USEDEFAULT,           // initial x position
                    CW_USEDEFAULT,           // initial y position
                    CW_USEDEFAULT,           // initial x size
                    CW_USEDEFAULT,           // initial y size
                    NULL,                    // parent window handle
                    NULL,                    // window menu handle
                    hInstance,               // program instance handle
		              NULL) ;		            // creation parameters

	//window
    ShowWindow (hwnd, iCmdShow) ;
    UpdateWindow (hwnd) ;
	//menu
	hmenu1=LoadMenu(NULL,"ATOM");
	SetMenu(NULL,hmenu1);
	//timer
	SetTimer(hwnd,1,10,0);
	//COM port init
	SerialInit();

     while (GetMessage (&msg, NULL, 0, 0)){
          TranslateMessage (&msg) ;
          DispatchMessage (&msg) ;
     }
     return msg.wParam;
}

//************************* WINDOW PROCEDURE ***********************************

LRESULT CALLBACK WndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam){
     HDC         hdc ;
     PAINTSTRUCT ps ;
	 HMENU		 hmenu;
	 int xv,w,rovid,q;
	 LOGFONT	lf;
	 HFONT		hf; 
	 char		c;
	 int		checksum;
	 
	 hmenu=GetMenu(hwnd);
	 
     switch (iMsg){
          case WM_CREATE :					// Initialization
			cx=cy=0;							//cursor
			for(y=0;y<25;y++){for(x=0;x<80;x++)display[y][x]=' ';}
			display[0][0]='*';
			finit(hwnd,&ofn);				//file
			print("PIC I8085 loader program (c) Andras Bognar, Quenne Electric 2007\n\n");
			print("Connecting...\n");
			push(0xFA);push(0xFA);push(0xFA); vart=3; muvelet=CONNECT;//connecting to device
			rec[0]=0;rec[1]=0;rec[2]=0;
            return 0 ;

          case WM_PAINT :
			hdc = BeginPaint (hwnd, &ps) ;		//Get DC handle
            GetClientRect (hwnd, &rect) ;		//Get client rectangle
			lf.lfHeight=(rect.bottom-rect.top)/26;
			lf.lfWidth=(rect.right-rect.left)/80;
			lf.lfEscapement=0;					//Forgatsi Szg
			lf.lfUnderline=FALSE;
			lf.lfStrikeOut=FALSE;
			lf.lfItalic=FALSE;
			strcpy(lf.lfFaceName,"Courier New");
			hf=CreateFontIndirect(&lf);
			SelectObject(hdc,hf); 
			x=0;
			for(y=0;y<25;y++){
				TextOut(hdc,5,x,display[y],80);x+=(rect.bottom-rect.top)/26;
			}
			EndPaint (hwnd, &ps) ;				//Release DC
            return 0 ;

          case WM_DESTROY :
			CloseHandle(m_hCom);
            PostQuitMessage (0) ;         // Exit from the program
            return 0 ;

		  case WM_COMMAND:
			switch(LOWORD(wParam)){
				case ID_M1://EEPROM Writing from file
					if(!muvelet&&connected){
						print("EEPROM writing from file\n");
						Megnyit(hwnd,lpstrTeljesAllNev,lpstrAllNev,&ofn);
						if((fp=fopen(lpstrTeljesAllNev,"rb"))==NULL){
							print("ERROR opening file\n");return 0;
						}
						rovid=0;
						for(xv=0;xv<256;xv++){
							if((w=getc(fp))!=EOF){
								push(0x13);push(xv);push(w);
							}
							else {rovid=1;push(0x13);push(xv);push(0x00);}
						}
						if(rovid)print("File is too short\n");
						muvelet=EEwrite;vart=256;
						fclose(fp);
					}
					break;
				case ID_M2://EEPROM Reading to file
					if(!muvelet&&connected){
						print("EEPROM reading to file\n");
						Mentes(hwnd,lpstrTeljesAllNev,lpstrAllNev,&ofn);
						for(xv=0;xv<256;xv++){//instr. out
							push(0x14);push(xv);
						}
						muvelet=EEread;vart=512;
					}
					break;
				case ID_M3://About
					MessageBox(hwnd,"Copyright(c) Andras Bognar, Quenne Electric company","About",
								MB_ICONEXCLAMATION|MB_OK);
					break;
				case ID_M4://Help
					MessageBox(hwnd,"PIC-I8085 Loader program","Help",
								MB_ICONEXCLAMATION|MB_OK);
					break;
				case ID_M5://Reconnect
					CloseHandle(m_hCom);
					BAUD=19200;SerialInit();
					connected=0;print("\nReconnecting...\n");connecttime=0;
					push(0xFA);push(0xFA);push(0xFA); vart=3; muvelet=CONNECT;//connecting to device
					rec[0]=0;rec[1]=0;rec[2]=0;
					break;
				case ID_M6://Reinit Serial
					CloseHandle(m_hCom);
					SerialInit();
					break;
				case ID_M7://Winchester write
					if(!muvelet&&connected){
						print("\n\nWinchester writing from file\n");
						CreateDialog(hinst,MAKEINTRESOURCE(IDD_DIALOG1),hwnd,DialogProc);
						Megnyit(hwnd,lpstrTeljesAllNev,lpstrAllNev,&ofn);
						push(0x25);push(sec);push(cyll);push(cylh);push(hd);
						if((fp=fopen(lpstrTeljesAllNev,"rb"))==NULL){
							print("ERROR opening file\n");return 0;
						}
						rovid=0;
						for(xv=0;xv<512;xv++){
							if((w=getc(fp))!=EOF)push(w);
							else {push(0x00);rovid=1;}
						}
						if(rovid)print("File is too short\n");
						fclose(fp);
						muvelet=Wwrite;vart=1;
					}
					break;
				case ID_M8://Winchester read
					if(!muvelet&&connected){
						print("\n\nWinchester reading to file\n");
						CreateDialog(hinst,MAKEINTRESOURCE(IDD_DIALOG1),hwnd,DialogProc);
						Mentes(hwnd,lpstrTeljesAllNev,lpstrAllNev,&ofn);
						push(0x26);push(sec);push(cyll);push(cylh);push(hd);
						muvelet=Wread;vart=512;
					}
					break;
				case ID_M9://Split file to 4 sector
					print("\n\nSplit File to 4 sectors\n");
					Megnyit(hwnd,lpstrTeljesAllNev,lpstrAllNev,&ofn);
					if((fp=fopen(lpstrTeljesAllNev,"rb"))==NULL){
						print("ERROR opening file\n");return 0;
					}
					for(xv=0;xv<256;xv++)w=getc(fp);//el olvass
					for(xv=0;xv<2048;xv++){
						if((w=getc(fp))!=EOF)fbuffer[xv]=w;
						else fbuffer[xv]=0;
					}
					fclose(fp);
					fbpoi=0;
					if((split=fopen("split1.bin","wb"))==NULL){//SPLIT1
						print("ERROR opening SPLIT1 file\n");return 0;
					}
					for(xv=0;xv<512;xv++){putc(fbuffer[fbpoi++],split);}
					fclose(split);
					if((split=fopen("split2.bin","wb"))==NULL){//SPLIT2
						print("ERROR opening SPLIT2 file\n");return 0;
					}
					for(xv=0;xv<512;xv++){putc(fbuffer[fbpoi++],split);}
					fclose(split);
					if((split=fopen("split3.bin","wb"))==NULL){//SPLIT3
						print("ERROR opening SPLIT3 file\n");return 0;
					}
					for(xv=0;xv<512;xv++){putc(fbuffer[fbpoi++],split);}
					fclose(split);
					if((split=fopen("split4.bin","wb"))==NULL){//SPLIT4
						print("ERROR opening SPLIT4 file\n");return 0;
					}
					for(xv=0;xv<512;xv++){putc(fbuffer[fbpoi++],split);}
					fclose(split);
					print("Splitting finished\n");
					break;
				case ID_M10://Store all sectors of the file to the boot area
					if(!muvelet&&connected){
						print("\n\nStore all sectors of the file to the boot area\n");
						Megnyit(hwnd,lpstrTeljesAllNev,lpstrAllNev,&ofn);
						if((fp=fopen(lpstrTeljesAllNev,"rb"))==NULL){
							print("ERROR opening file\n");return 0;
						}
						for(xv=0;xv<256;xv++)w=getc(fp);//el olvass
						for(q=0;q<4;q++){
							push(0x25);push(q+1);push(0);push(0);push(10);
							for(xv=0;xv<512;xv++){
								if((w=getc(fp))!=EOF)push(w);
								else push(0x00);
							}
						}
						fclose(fp);
						RECTIMEMAX=1000;muvelet=StoreAll;vart=4;
					}
					break;
				case ID_M11://Record from serial port
					if(!muvelet&&connected){
						CloseHandle(m_hCom);
						SerialInit();
						print("\n\nRecord from serial port\n");
						print("Press 's' to stop recording\n");
						SR=1;
					}
					break;
				case ID_TEST1://Test1
					print("Test1\n");
					Mentes(hwnd,lpstrTeljesAllNev,lpstrAllNev,&ofn);
					if((fp=fopen(lpstrTeljesAllNev,"wb"))==NULL){
						print("ERROR opening file\n");return 0;
					}
					for(xv=0;xv<256;xv++){
						putc(xv,fp);putc(xv,fp);
					}
					fclose(fp);
					break;
				case ID_TEST2://Test2
					print("Test2\n");
					Mentes(hwnd,lpstrTeljesAllNev,lpstrAllNev,&ofn);
					if((fp=fopen(lpstrTeljesAllNev,"wb"))==NULL){
						print("ERROR opening file\n");return 0;
					}
					for(xv=0;xv<256;xv++){
						putc(xv,fp);putc(0,fp);
					}
					fclose(fp);
					break;
				case ID_TEST3://Test3
					print("Test3\n");
					Megnyit(hwnd,lpstrTeljesAllNev,lpstrAllNev,&ofn);
					if((fp=fopen(lpstrTeljesAllNev,"rb"))==NULL){
						print("ERROR opening SOURCE file\n");return 0;
					}
					checksum=0;
					for(xv=0;xv<256;xv++)getc(fp);
					for(xv=0;xv<2048;xv++)if((w=getc(fp))!=EOF){checksum+=w;}

					fclose(fp);
					print("\nComputed=");print((unsigned int)0xff&checksum);print("\n");
					break;
				case ID_8SPLITSTORE://Split to 8 sector and store, only upper byte is valid
					if(!muvelet&&connected){
						print("\n\nSplit to 8 upper byte sectors and store to the boot area\n");
						Megnyit(hwnd,lpstrTeljesAllNev,lpstrAllNev,&ofn);
						if((fp=fopen(lpstrTeljesAllNev,"rb"))==NULL){
							print("ERROR opening file\n");return 0;
						}
						//generate checksum 
						for(xv=0;xv<256;xv++)w=getc(fp);//el olvass
						w=getc(fp);checksum=0;
						for(xv=0;xv<2047;xv++)if((w=getc(fp))!=EOF)checksum+=w;
						checksum&=0xFF; checksum=256-checksum; checksum&=0xFF;
						print("Checksum=");print((unsigned int)checksum);print("\n");
						fclose(fp);
						//Store sectors
						if((fp=fopen(lpstrTeljesAllNev,"rb"))==NULL){
							print("ERROR opening file\n");return 0;
						}
						for(xv=0;xv<256;xv++)w=getc(fp);//el olvass
						for(q=0;q<8;q++){
							push(0x25);push(q+1);push(0);push(0);push(10);
							for(xv=0;xv<256;xv++){
								if((w=getc(fp))!=EOF){
									if((q==0)&&(xv==0)){push(checksum);push(0);}
									else {push(w);push(0);}
								}
								else {push(0);push(0);}
							}
						}
						fclose(fp);
						RECTIMEMAX=1000;muvelet=x8split;vart=8;
					}
					break;
				case ID_TRUNC://Truncate the first 256byte of the file (testing)
					print("Truncate the first 256byte of the file (testing)");
					Megnyit(hwnd,lpstrTeljesAllNev,lpstrAllNev,&ofn);
					if((fp=fopen(lpstrTeljesAllNev,"rb"))==NULL){
						print("ERROR opening file\n");return 0;
					}
					for(xv=0;xv<256;xv++)getc(fp);
					for(xv=0;xv<2048;xv++){
						if((w=getc(fp))!=EOF)fbuffer[xv]=w;
						else fbuffer[xv]=0;
					}
					fclose(fp);
					if((fp=fopen("trunc.bin","wb"))==NULL){
						print("ERROR opening file\n");return 0;
					}
					for(xv=0;xv<2048;xv++){
						putc(fbuffer[xv],fp);
					}
					fclose(fp);
					break;
				case ID_HACK://machine code (virus) into hexadecimal characters to send in e-mail
					print("\nMake machine code (virus) into hexadecimal characters to send in e-mail\n");
					Megnyit(hwnd,lpstrTeljesAllNev,lpstrAllNev,&ofn);
					if((fp=fopen(lpstrTeljesAllNev,"rb"))==NULL){
						print("ERROR opening file\n");return 0;
					}
					q=0;
					for(xv=0;xv<65536;xv++){		//max. 65536 byte 
						if((w=getc(fp))!=EOF){fbuffer[xv]=w;q++;}
						else fbuffer[xv]=0;
					}
					fclose(fp);

					Mentes(hwnd,lpstrTeljesAllNev,lpstrAllNev,&ofn);
					if((fp=fopen(lpstrTeljesAllNev,"wb"))==NULL){
						print("ERROR opening file\n");return 0;
					}


					w=0;
					while(w<q){
						putc('E',fp);convert(w+256);
						xv=0;while(input[xv]!=0){
							putc(input[xv++],fp);
						}putc(' ',fp);
						for(xv=0;xv<16;xv++){
							convert(fbuffer[w++]);
							putc(input[0],fp);putc(input[1],fp);
							putc(' ',fp);
						}
						putc(13,fp);putc(10,fp);
					}

					fclose(fp);
					break;
				case ID_FORCE:	//Force "connected" sate to terminal
					print("\nConnection forced - RS232 terminal");CONNECT_proc();
					break;
				case ID_BAUD_1://setting up baud rates
					BAUD=9600;CloseHandle(m_hCom);SerialInit();
					break;
				case ID_BAUD_2:
					BAUD=19200;CloseHandle(m_hCom);SerialInit();
					break;
				case ID_BAUD_3:
					BAUD=115200;CloseHandle(m_hCom);SerialInit();
					break;
				case ID_BAUD_4:
					BAUD=230400;CloseHandle(m_hCom);SerialInit();
					break;
				case ID_BAUD_5:
					BAUD=460800;CloseHandle(m_hCom);SerialInit();
					break;
				case ID_BAUD_6:
					BAUD=921600;CloseHandle(m_hCom);SerialInit();
					break;
				case ID_BAUD_7:
					BAUD=1250000;CloseHandle(m_hCom);SerialInit();
					break;
				case ID_PERIODIC: //test mode: periodic sending
					if(!periodic){periodic=1;print("Periodic sending (0x55)\n");}
					else {periodic=0;print("Periodc mode stopped\n");}
					break;
				}
			return 0;

		case WM_KEYDOWN:						//Billenty vezrls
			switch(wParam){
				case VK_UP:
					print("\nKuldendo parancs (hexadec 8bit): ");
					//Bevitelndts
					bevitel=1;bp=0;
					break;

				case 13:
					if(bevitel==1){
						bevitel=0;input[bp]=0;
						print(char(10));
						//Kliens vlasza
						if(input[0]>96)input[0]=input[0]-32;
						if(input[1]>96)input[1]=input[1]-32;
						x=((input[1]<58)?input[1]-48:input[1]-55)+16*((input[0]<58)?input[0]-48:input[0]-55);
						print("decimal=");print(x);print("\n");
						input[0]=x;input[1]=0;
						bWriteRC = WriteFile(m_hCom,input,1,&iBytesWritten,NULL);
					}
					break;

				case 8:							//Backspace
					display[cy][cx]=' ';
					bp--;cx--;
					display[cy][cx]='*';
					GetClientRect (hwnd, &rect);
					InvalidateRect(hwnd,&rect,FALSE);
					break;
			}
			return 0;
		   
		case WM_CHAR:							//Billentybevitel
			c=(char)wParam;
			if(bevitel){
				if(((c>'A'-1)&&(c<'Z'+1))||((c>'a'-1)&&(c<'z'+1))||((c>'0'-1)&&(c<'9'+1))||
					(c=='+')||(c=='!')||(c=='%')||(c=='/')||(c=='=')||(c=='(')||
					(c==')')||(c==' ')||(c==',')||(c==';')||(c=='-')){
					print(c); input[bp++]=c;
				}
			}
			else{
				if(c=='s')RecSerial_proc();//stop serial recording
			}
			return 0;

		case WM_TIMER:	//soros ads-vtel idzts
			//periodic sending - test setting
			if(periodic){sBuffer[0]=0x55;WriteFile(m_hCom,sBuffer,1,&iBytesWritten,NULL);return 0;}

			//adsra vrs
			if(!empty()){
				sBuffer[0]=pop();
				if(muvelet&&connected){print((unsigned int)sBuffer[0]&0xFF);print(",");}
				WriteFile(m_hCom,sBuffer,1,&iBytesWritten,NULL);
			}
			else{ 
				if(muvelet==Wwrite){muvelet=0;Wwrite_proc();}
				if(muvelet==StoreAll){muvelet=0;StoreAll_proc();}
				if(muvelet==x8split){muvelet=0;x8split_proc();}
			}

			//csatlakozsi idzts
			if(!connected){
				connecttime++;
				if(connecttime==30){
					w=rec[0]&0xFF;
					if(w==0xFA)CONNECT_proc();
					else {
						w=rec[1]&0xFF;if(w==0xFA)CONNECT_proc();
						else {
							w=rec[2]&0xFF;if(w==0xFA)CONNECT_proc();
							else {
								print("\nERROR - connection failed\n");
								MessageBox(hwnd,"Connection failed","ERROR",
											MB_ICONSTOP|MB_OK);
							}
						}
					}
				}
			}

			//2 vtel kzt eltelt id szmolsa
			if(vart&&muvelet&&connected&&(!dataproc)){
				rectime++;
				if(rectime==RECTIMEMAX){
					muvelet=0;connected=0;eleje=buffer;vege=buffer;connecttime==31;
					MessageBox(hwnd,"Connection lost","ERROR",MB_ICONSTOP|MB_OK);
				}
			}
			else rectime=0;

			//jtt-e adat?	
			ReadFile(m_hCom,&sBuffer,1,&iBytesRead,NULL);
			if(iBytesRead){
				if(muvelet){
					rec[rpoi]=sBuffer[0];rpoi++;			//print((unsigned int)sBuffer[0]);print(',');
					vart--;	rectime=0;						//print("\nvart=");print(vart);print("\n");
					if(!vart){
						dataproc=1;
						switch(muvelet){
						case EEwrite:	EEwrite_proc();	break;
						case EEread:	EEread_proc();	break;
						case Wread:		Wread_proc();	break;
						case CONNECT:	CONNECT_proc();	break;
						}	
						rpoi=0;dataproc=0;
						if((muvelet!=Wwrite)&&(muvelet!=StoreAll)&&(muvelet!=x8split))muvelet=0;
					}
				}
				else{
					if(connected){//gyorsteszt vlasza
						print("Received data= ");print((unsigned int)sBuffer[0]&0xFF);
						print("     ");print('"');print(sBuffer[0]);print('"');
						if(SR){//file-ba vesz
							SRbuf[SRpoi++]=sBuffer[0];if(SRpoi>4999)SRpoi=4999;
							print(" SAVED TO FILE ");
						}
						print("\n");
					}
				}
			}
			
			return 0;
     }

     return DefWindowProc (hwnd, iMsg, wParam, lParam) ; // Call the default window procedure
}
